"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetModelTabKey = exports.GetTabTypeAndIDFromTabKey = exports.ValidateRunTypeConstraint = exports.IsUserAdmin = exports.GetUserContextFromUserConnection = exports.ESettingsState = exports.GetCloudSchedulerAddress = exports.GetApplicationAddress = exports.InitializeStepsSelectState = exports.EStepsSelectsOptions = exports.ColumnMegagridStepSelectStateKey = exports.DocColumnStepSelectStateKey = exports.DocStepsSelectStateKey = exports.MegagridStepsSelectStateKey = exports.LeftbarStepsSelectStateKey = exports.GetColumnHashType = exports.ColumnDataPromiseResolver = exports.generateKey = exports.getNextEntityCounter = exports.ECollectionRefs = exports.OrgField = exports.getNextCounter = exports.NextCounterGetter = exports.TransactionNextCounterGetter = exports.getOrgDataDocRef = exports.getCollectionRef = exports.getOrgConfigDocRef = exports.getOrgPublicDocRefAdmin = exports.getOrgPublicDocRef = exports.getRunsRange = exports.getCollectionLimited = exports.DocumentExistsAdmin = exports.getOrgsCollectionAdmin = exports.getDocumentRefAdmin = exports.getWorkspaceDocumentRefAdmin = exports.getUserDocRefAdmin = exports.getOrgConfigDocRefAdmin = exports.getOrgDataDocRefAdmin = exports.getOrgsPublicCollectionAdmin = exports.getOrgsPublicCollection = exports.getOrgsCollection = exports.getUsersCollection = exports.GetUserContextFromState = exports.GetUserContextByUserAuthType = exports.ECounterKeys = exports.EOrgFlags = exports.OrgFlags = exports.ELastActiveUI = exports.EDataType = void 0;
const Firebase = __importStar(require("./Firebase"));
const Common = __importStar(require("./Common"));
const TeamOperations = __importStar(require("./TeamOperations"));
const Runner = __importStar(require("./Runner"));
const ConnectionOperations = __importStar(require("./ConnectionOperations"));
const Logging = __importStar(require("./Logging"));
var EDataType;
(function (EDataType) {
    //todo:clarify
    EDataType["FIXED"] = "NUMBER";
    EDataType["REAL"] = "REAL";
    EDataType["TEXT"] = "VARCHAR";
    EDataType["DATE"] = "DATE";
    EDataType["TIMESTAMP"] = "TIMESTAMP";
    EDataType["VARIANT"] = "VARIANT";
    EDataType["TIMESTAMP_LTZ"] = "TIMESTAMP_LTZ";
    EDataType["TIMESTAMP_TZ"] = "TIMESTAMP_TZ";
    EDataType["TIMESTAMP_NTZ"] = "TIMESTAMP_TZ";
    EDataType["OBJECT"] = "OBJECT";
    EDataType["ARRAY"] = "ARRAY";
    EDataType["BINARY"] = "BINARY";
    EDataType["TIME"] = "TIME";
    EDataType["BOOLEAN"] = "BOOLEAN";
})(EDataType = exports.EDataType || (exports.EDataType = {}));
var ELastActiveUI;
(function (ELastActiveUI) {
    ELastActiveUI["stepGraph"] = "graph";
    ELastActiveUI["categoryTree"] = "categoryTree";
})(ELastActiveUI = exports.ELastActiveUI || (exports.ELastActiveUI = {}));
var OrgFlags;
(function (OrgFlags) {
    OrgFlags["dataVaultEnabled"] = "Data Vault Enabled";
})(OrgFlags = exports.OrgFlags || (exports.OrgFlags = {}));
var EOrgFlags;
(function (EOrgFlags) {
    EOrgFlags["dataVaultEnabled"] = "dataVaultEnabled";
})(EOrgFlags = exports.EOrgFlags || (exports.EOrgFlags = {}));
var ECounterKeys;
(function (ECounterKeys) {
    ECounterKeys["stepCounter"] = "stepCounter";
    ECounterKeys["columnCounter"] = "columnCounter";
    ECounterKeys["workspaceCounter"] = "workspaceCounter";
    ECounterKeys["jobCounter"] = "jobCounter";
    ECounterKeys["folderCounter"] = "folderCounter";
    ECounterKeys["locationCounter"] = "locationCounter";
    ECounterKeys["connectionCounter"] = "connectionCounter";
    ECounterKeys["templateCounter"] = "templateCounter";
    ECounterKeys["runCounter"] = "runCounter";
})(ECounterKeys = exports.ECounterKeys || (exports.ECounterKeys = {}));
const GetUserContextByUserAuthType = (state, workspaceID, userConnectionOverride) => {
    const authInfo = Common.getValueSafe(state, ["auth"], {});
    const userID = Common.getValueSafe(authInfo, ["fbUserID"], -1);
    const orgID = Common.getValueSafe(authInfo, ["fbTeamID"], -1);
    let userConnection = Common.getValueSafe(state, ["userConnections", workspaceID, userID], {});
    const { connectionType } = userConnection;
    const user = ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnection, ConnectionOperations.EUserConnectionDetail.user);
    const role = ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnection, ConnectionOperations.EUserConnectionDetail.role);
    const warehouse = ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnection, ConnectionOperations.EUserConnectionDetail.warehouse);
    const workspace = Common.getValueSafe(state, ["workspaces", "workspaces", workspaceID], {});
    if (userConnectionOverride !== null) {
        userConnection = userConnectionOverride;
    }
    //Two options (for now, auth or basic) if the state isn't there, we generate a 'dumb' usercontext so we can catch and log error messages appropriately at the run level
    if (connectionType === ConnectionOperations.EUserConnectionTypes.oauth) {
        const contextObject = {
            accountName: workspace.connectionAccount || "",
            user,
            role,
            warehouse,
            orgID: orgID,
            environmentID: workspaceID,
            authenticator: ConnectionOperations.EUserConnectionTypes.oauth
        };
        return contextObject;
    }
    else {
        const context = (0, exports.GetUserContextFromState)(state, workspaceID, userConnection, workspace);
        return context;
    }
};
exports.GetUserContextByUserAuthType = GetUserContextByUserAuthType;
const GetUserContextFromState = (state, workspaceID, userConnection, workspace) => {
    const connectionState = Common.getValueSafe(state, ["deploymentCredentials", workspaceID], {});
    /**
     * frankenstein together the bits of data from their respective/trusted resources
     * for basic auth, we store the password on the client browser and everything else on firestore in the
     * userConnection
     */
    return {
        user: ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnection, ConnectionOperations.EUserConnectionDetail.user),
        password: connectionState.snowflakePassword || "",
        accountName: workspace.connectionAccount || "",
        warehouse: ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnection, ConnectionOperations.EUserConnectionDetail.warehouse),
        role: ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnection, ConnectionOperations.EUserConnectionDetail.role),
        orgID: TeamOperations.getOrgIDFromState(state),
        environmentID: workspaceID,
        authenticator: userConnection.connectionType
    };
};
exports.GetUserContextFromState = GetUserContextFromState;
const getUsersCollection = () => {
    return Firebase.getFirestore().collection("users");
};
exports.getUsersCollection = getUsersCollection;
const getOrgsCollection = () => {
    return Firebase.getFirestore().collection("orgs");
};
exports.getOrgsCollection = getOrgsCollection;
const getOrgsPublicCollection = () => {
    return Firebase.getFirestore().collection("orgsPublic");
};
exports.getOrgsPublicCollection = getOrgsPublicCollection;
const getOrgsPublicCollectionAdmin = (firestore) => {
    return firestore.collection("orgsPublic");
};
exports.getOrgsPublicCollectionAdmin = getOrgsPublicCollectionAdmin;
// Admin specific fb operations
const getOrgDataDocRefAdmin = (firestore, teamID) => {
    return firestore.collection("orgs").doc(teamID);
};
exports.getOrgDataDocRefAdmin = getOrgDataDocRefAdmin;
const getOrgConfigDocRefAdmin = (firestore, teamID) => {
    return (0, exports.getOrgDataDocRefAdmin)(firestore, teamID);
};
exports.getOrgConfigDocRefAdmin = getOrgConfigDocRefAdmin;
const getUserDocRefAdmin = (firestore, userID) => {
    return firestore.collection("users").doc(userID);
};
exports.getUserDocRefAdmin = getUserDocRefAdmin;
const getWorkspaceDocumentRefAdmin = (firestore, teamID, workspaceID) => {
    return (0, exports.getOrgDataDocRefAdmin)(firestore, teamID).collection("workspaces").doc(workspaceID.toString());
};
exports.getWorkspaceDocumentRefAdmin = getWorkspaceDocumentRefAdmin;
const getDocumentRefAdmin = (firestore, teamID, workspaceID, refName) => {
    return (0, exports.getWorkspaceDocumentRefAdmin)(firestore, teamID, workspaceID).collection(refName);
};
exports.getDocumentRefAdmin = getDocumentRefAdmin;
const getOrgsCollectionAdmin = (firestore) => {
    return firestore.collection("orgs");
};
exports.getOrgsCollectionAdmin = getOrgsCollectionAdmin;
const DocumentExistsAdmin = (firestore, teamID, workspaceID, collection, jobID) => {
    return (0, exports.getDocumentRefAdmin)(firestore, teamID, workspaceID, collection).doc(jobID.toString()).get()
        .then(doc => {
        const data = doc.data();
        return !!data;
    }).catch(error => {
        console.error(`Error getting ${collection} details` + error);
        throw error;
    });
};
exports.DocumentExistsAdmin = DocumentExistsAdmin;
const getCollectionLimited = (firestore, teamID, collection, field, limit) => {
    return (0, exports.getOrgDataDocRefAdmin)(firestore, teamID).collection(collection).orderBy(field, "desc").limit(limit);
};
exports.getCollectionLimited = getCollectionLimited;
const getRunsRange = (firestore, teamID, upperLimitInclusive, lowerLimitExclusive) => {
    return (0, exports.getOrgDataDocRefAdmin)(firestore, teamID).collection("runs").where("id", "<=", upperLimitInclusive).where("id", ">", lowerLimitExclusive).orderBy("id", "desc");
};
exports.getRunsRange = getRunsRange;
// general fb operations
const getOrgPublicDocRef = (teamID) => {
    return (0, exports.getOrgsPublicCollection)().doc(teamID);
};
exports.getOrgPublicDocRef = getOrgPublicDocRef;
const getOrgPublicDocRefAdmin = (firestore, teamID) => {
    return (0, exports.getOrgsPublicCollectionAdmin)(firestore).doc(teamID);
};
exports.getOrgPublicDocRefAdmin = getOrgPublicDocRefAdmin;
const getOrgConfigDocRef = (teamID) => {
    return (0, exports.getOrgDataDocRef)(teamID);
};
exports.getOrgConfigDocRef = getOrgConfigDocRef;
const getCollectionRef = (teamID, workspaceID, refName) => {
    return (0, exports.getOrgDataDocRef)(teamID).collection("workspaces").doc(workspaceID.toString()).collection(refName);
};
exports.getCollectionRef = getCollectionRef;
const getOrgDataDocRef = (teamID) => {
    return (0, exports.getOrgsCollection)().doc(teamID);
};
exports.getOrgDataDocRef = getOrgDataDocRef;
const TransactionNextCounterGetter = (transaction, counterKey) => {
    return (orgDocRef, increment) => {
        return getNextCounterWithTransaction(transaction, orgDocRef, counterKey, increment);
    };
};
exports.TransactionNextCounterGetter = TransactionNextCounterGetter;
const NextCounterGetter = (counterKey) => {
    return (orgDocRef, increment) => {
        const firestore = Firebase.getFirestore();
        return (0, exports.getNextCounter)(firestore, orgDocRef, counterKey, increment);
    };
};
exports.NextCounterGetter = NextCounterGetter;
const getNextCounterWithTransaction = (transaction, docRef, counterKey, increment) => {
    return transaction.get(docRef)
        .then((configSnapshot) => {
        let currentHighestCounterValue = 0;
        if (configSnapshot.data() && configSnapshot.data()[counterKey])
            currentHighestCounterValue = configSnapshot.data()[counterKey];
        transaction.set(docRef, {
            [counterKey]: currentHighestCounterValue + increment
        }, { merge: true });
        return currentHighestCounterValue + 1;
    });
};
const getNextCounter = (firestore, docRef, counterKey, increment) => {
    return new Promise((resolve, reject) => {
        firestore.runTransaction((t) => {
            return getNextCounterWithTransaction(t, docRef, counterKey, increment);
        }).then(nextCounter => {
            resolve(nextCounter);
        }).catch((error) => {
            reject(error);
        });
    });
};
exports.getNextCounter = getNextCounter;
/////////// Entity API
var OrgField;
(function (OrgField) {
    OrgField["jobCounter"] = "jobCounter";
    OrgField["connectionCounter"] = "connectionCounter";
    OrgField["macroCounter"] = "macroCounter";
    OrgField["stepCounter"] = "stepCounter";
    OrgField["folderCounter"] = "folderCounter";
    OrgField["templateCounter"] = "templateCounter";
    OrgField["userCounter"] = "userCounter";
    OrgField["projectCounter"] = "projectCounter";
})(OrgField = exports.OrgField || (exports.OrgField = {}));
var ECollectionRefs;
(function (ECollectionRefs) {
    ECollectionRefs["steps"] = "steps";
    ECollectionRefs["folders"] = "folders";
    ECollectionRefs["jobs"] = "jobs";
    ECollectionRefs["macros"] = "macros";
    ECollectionRefs["templates"] = "templates";
    ECollectionRefs["users"] = "users";
    ECollectionRefs["packages"] = "packages";
    ECollectionRefs["usersAdmin"] = "usersAdmin";
    ECollectionRefs["orgs"] = "orgs";
    ECollectionRefs["orgsPublic"] = "orgsPublic";
    ECollectionRefs["mappings"] = "mappings";
    ECollectionRefs["runtimeParameters"] = "runtimeParameters";
    ECollectionRefs["workspaces"] = "workspaces";
    ECollectionRefs["projects"] = "projects";
})(ECollectionRefs = exports.ECollectionRefs || (exports.ECollectionRefs = {}));
const getNextEntityCounter = (increment, teamID, orgField) => {
    const firestore = Firebase.getFirestore();
    return (0, exports.getNextCounter)(firestore, (0, exports.getOrgConfigDocRef)(teamID), orgField, increment);
};
exports.getNextEntityCounter = getNextEntityCounter;
const generateKey = (keyStrings) => {
    return keyStrings.join("-");
};
exports.generateKey = generateKey;
const ColumnDataPromiseResolver = (ignoredData, columnData) => {
    return new Promise((resolve, reject) => {
        resolve(columnData);
    });
};
exports.ColumnDataPromiseResolver = ColumnDataPromiseResolver;
const GetColumnHashType = (column) => {
    return Common.getValueSafe(column, ["hashDetails", "hashType"], Runner.EHashType.none);
};
exports.GetColumnHashType = GetColumnHashType;
exports.LeftbarStepsSelectStateKey = "leftBarStepsSelect";
exports.MegagridStepsSelectStateKey = "megagridStepsSelect";
exports.DocStepsSelectStateKey = "megagridStepsSelect";
exports.DocColumnStepSelectStateKey = "docColumnStepsSelect";
exports.ColumnMegagridStepSelectStateKey = "columnMegagridStepSelect";
var EStepsSelectsOptions;
(function (EStepsSelectsOptions) {
    EStepsSelectsOptions["LeftbarStepsSelectStateKey"] = "leftBarStepsSelect";
    EStepsSelectsOptions["MegagridStepsSelectStateKey"] = "megagridStepsSelect";
    EStepsSelectsOptions["DocStepsSelectStateKey"] = "megagridStepsSelect";
    EStepsSelectsOptions["DocColumnStepSelectStateKey"] = "docColumnStepsSelect";
})(EStepsSelectsOptions = exports.EStepsSelectsOptions || (exports.EStepsSelectsOptions = {}));
const InitializeStepsSelectState = () => {
    const output = {};
    Object.values(EStepsSelectsOptions).forEach((val) => {
        output[val] = {};
    });
    return output;
};
exports.InitializeStepsSelectState = InitializeStepsSelectState;
const GetApplicationAddress = () => {
    try {
        const address = window.location.origin;
        return address;
    }
    catch (error) {
        if (!!process.env.APPLICATION_ADDRESS) {
            return process.env.APPLICATION_ADDRESS;
        }
    }
    return (0, exports.GetCloudSchedulerAddress)();
};
exports.GetApplicationAddress = GetApplicationAddress;
const GetCloudSchedulerAddress = () => {
    const environment = Firebase.GetEnvironment();
    switch (environment) {
        case "development":
            /*
             * when developing, override with localhost:PORT
             *  return "http://host.docker.internal:9000"
             */
            return process.env.SCHEDULER_ADDRESS || "https://dev.app.coalescestage.io";
        case "qa":
            return "https://qa.app.coalescestage.io";
        case "production":
            return "https://app.coalescesoftware.io";
        default:
            return "";
    }
};
exports.GetCloudSchedulerAddress = GetCloudSchedulerAddress;
var ESettingsState;
(function (ESettingsState) {
    ESettingsState[ESettingsState["initial"] = 1] = "initial";
    ESettingsState[ESettingsState["loading"] = 2] = "loading";
    ESettingsState[ESettingsState["success"] = 3] = "success";
    ESettingsState[ESettingsState["fail"] = 4] = "fail";
})(ESettingsState = exports.ESettingsState || (exports.ESettingsState = {}));
const GetUserContextFromUserConnection = (environmentID, connectionAccount, userConnection, password, orgID, userID) => {
    let userConnectionToUse = userConnection;
    Common.assert(Logging.LoggingArea.Common, userConnection.hasOwnProperty("connectionDetails"), `connectionDetails exists for orgid ${orgID} ${userID}`);
    Common.assert(Logging.LoggingArea.Connection, ConnectionOperations.IsValidIUserConnection(userConnection), `is valid IUserConnection ${orgID} ${userID}`);
    Common.assert(Logging.LoggingArea.Connection, Common.getEnumSafe(ConnectionOperations.EUserConnectionTypes, userConnection.connectionType, `value of connectionType in user connection is not in userconnection type enum ${userConnection.connectionType}`));
    return {
        environmentID,
        accountName: connectionAccount,
        user: ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnectionToUse, ConnectionOperations.EUserConnectionDetail.user),
        password: password,
        warehouse: ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnectionToUse, ConnectionOperations.EUserConnectionDetail.warehouse),
        database: "",
        destinationSchema: "",
        role: ConnectionOperations.GetValueFromConnectionDetailsSafe(userConnectionToUse, ConnectionOperations.EUserConnectionDetail.role),
        orgID,
        authenticator: userConnection.connectionType
    };
};
exports.GetUserContextFromUserConnection = GetUserContextFromUserConnection;
const IsUserAdmin = (userRole) => {
    return userRole === TeamOperations.EUserRoles.ADMIN;
};
exports.IsUserAdmin = IsUserAdmin;
// see CD-2753 - we can use this in the future. https://github.com/pelotom/runtypes#constraint-checking
const ValidateRunTypeConstraint = (runType, objectToValidate) => {
    try {
        // .check throws an exception
        runType.check(objectToValidate);
        return { success: true, errorString: null };
    }
    catch (error) {
        return Object.assign({ success: false, errorString: error.message }, error);
    }
};
exports.ValidateRunTypeConstraint = ValidateRunTypeConstraint;
const GetTabTypeAndIDFromTabKey = (activeKey) => {
    const splitActiveKey = activeKey.split("-");
    const tabType = splitActiveKey[0]; // check getModelTabKey, splitActiveKey[0] will always be tabType
    const tabID = splitActiveKey.slice(1).join("-"); // in case of multiple dashes in activeKey, join remaining array items
    return { tabID, tabType };
};
exports.GetTabTypeAndIDFromTabKey = GetTabTypeAndIDFromTabKey;
const GetModelTabKey = (tabType, tabID) => {
    return `${tabType}-${tabID}`;
};
exports.GetModelTabKey = GetModelTabKey;
//# sourceMappingURL=CommonOperations.js.map