"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Persister = exports.cleanUserState = exports.getStartingState = exports.getPersister = exports.getFile = exports.saveFile = void 0;
const immer = __importStar(require("immer"));
const axios_1 = __importDefault(require("axios"));
const path = require('path');
const fs = require('fs');
//const electron  = require('electron')
const saveFile = (filename, contents) => __awaiter(void 0, void 0, void 0, function* () {
    const ret = yield axios_1.default.post(`/api/file?filename=${filename}`, contents, { headers: { "Content-Type": "text/plain" } });
    console.log("got ret", ret);
});
exports.saveFile = saveFile;
const getFile = (filename) => __awaiter(void 0, void 0, void 0, function* () {
    const ret = yield axios_1.default.get(`/api/file?filename=${filename}`);
    console.log("got ret get", ret);
    return ret.data;
});
exports.getFile = getFile;
let mainPersister = null;
const getPersister = () => {
    if (!mainPersister) {
        console.assert(mainPersister);
    }
    return mainPersister;
};
exports.getPersister = getPersister;
const getStartingState = (key) => {
    return new Promise((resolve, reject) => {
        var readData = window.localStorage.getItem(key);
        console.log("using local storage", readData);
        if (!readData) {
            resolve({});
        }
        else {
            resolve(JSON.parse(readData));
        }
    });
};
exports.getStartingState = getStartingState;
const cleanUserState = (jsonData) => {
    let myDataCopy = immer.produce(jsonData, (draftState) => {
        const runResultStepCounters = Object.keys(draftState['runResults']);
        for (let i in runResultStepCounters) {
            let runResult = draftState['runResults'][runResultStepCounters[i]];
            if ('previewResult' in runResult) {
                runResult['previewResult'].rows = [];
            }
            if ('createResult' in runResult) {
                runResult['createResult'].rows = [];
            }
        }
    });
    return myDataCopy;
};
exports.cleanUserState = cleanUserState;
class Persister {
    constructor(store, user) {
        this.saveIntervalMS = 10000;
        this.path = 'structure.data';
        this.user = '';
        this.setPath = (path) => {
            this.path = path;
            return;
        };
        this.getStore = () => {
            return this.myStore;
        };
        this.save = (data) => __awaiter(this, void 0, void 0, function* () {
            window.localStorage.setItem(this.path, JSON.stringify(data));
            return;
        });
        this.checkPersistChange = () => {
            if (this.dataCopy) {
                let myDataCopy = immer.produce(this.dataCopy, (draftState) => {
                    delete draftState["app"];
                    delete draftState["auth"];
                    delete draftState["companies"];
                    delete draftState["connections"];
                    delete draftState["dataSync"];
                    delete draftState["discover"];
                    delete draftState["router"];
                    delete draftState["users"];
                    delete draftState["steps"];
                    delete draftState["edges"];
                    delete draftState["orgFeatureFlags"];
                    delete draftState["orgData"];
                    delete draftState["modelViewerCurrentSteps"];
                    delete draftState["dropZoneParams"];
                    delete draftState["currentStepDoc"];
                    delete draftState["docsViewerState"];
                    delete draftState["workspaces"];
                    delete draftState["environments"];
                    delete draftState["mappings"];
                    delete draftState["currentSubGraph"];
                    delete draftState["folders"];
                    delete draftState["users"];
                    delete draftState["orgs"];
                    delete draftState["usersFirebase"];
                    delete draftState["adminUsersFirebase"];
                    delete draftState["runs"];
                    delete draftState["modal"];
                    delete draftState["jobs"];
                    delete draftState["runResults"];
                    delete draftState["stepTypesParsed"];
                    delete draftState["stepTypesYaml"];
                    delete draftState["templateEditor"];
                    delete draftState["userConnections"];
                });
                this.save(myDataCopy);
                this.dataCopy = null;
            }
        };
        this.handleChange = () => {
            let data = this.myStore.getState();
            //always save the changes in this.dataCopy
            let dataCopy = Object.assign({}, data);
            this.dataCopy = dataCopy;
        };
        this.myStore = store;
        this.unsubscribe = this.myStore.subscribe(this.handleChange);
        this.saving = false;
        this.lastSaveTime = Date.now();
        this.dataCopy = null;
        this.interval = setInterval(this.checkPersistChange, this.saveIntervalMS);
        mainPersister = this;
        this.user = user;
    }
}
exports.Persister = Persister;
//# sourceMappingURL=Data.js.map