"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MaskLogValue = exports.GetLogger = exports.GetBaseLogger = exports.CreateLogContext = exports.LogLevel = exports.LoggingAreas = exports.GetStandardDefaultMeta = exports.GetDefaultTransports = exports.GetOurTransport = exports.GetHttpTransport = exports.GetConsoleTransport = exports.ReconfigureLoggers = exports.SetHTTPTransportOptions = exports.SetBackendGlobalContext = exports.frontEndGlobalContext = exports.dataDogFrontEndLogger = exports.EHttpServices = exports.LoggingArea = void 0;
const Winston = __importStar(require("winston"));
const Common = __importStar(require("./Common"));
const Firebase = __importStar(require("./Firebase"));
const transport = require("winston-transport");
var LoggingArea;
(function (LoggingArea) {
    LoggingArea["Runner"] = "RUNNER";
    LoggingArea["Steps"] = "STEPS";
    LoggingArea["RunnerBackend"] = "RUNNER_BACKEND";
    LoggingArea["TreeOperations"] = "TREE_OPERATIONS";
    LoggingArea["StepTypes"] = "STEP_TYPES";
    LoggingArea["Graph"] = "GRAPH";
    LoggingArea["UI"] = "UI";
    LoggingArea["Testing"] = "TESTING";
    LoggingArea["DNS"] = "DNS";
    LoggingArea["APP"] = "APP";
    LoggingArea["Perf"] = "PERFORMANCE";
    LoggingArea["Deploy"] = "DEPLOY";
    LoggingArea["Firebase"] = "FIREBASE";
    LoggingArea["Connection"] = "CONNECTION";
    LoggingArea["Environments"] = "ENVIRONMENTS";
    LoggingArea["Jobs"] = "JOBS";
    LoggingArea["SQLParsing"] = "SQL_PARSING";
    LoggingArea["StorageLocations"] = "STORAGE_LOCATIONS";
    LoggingArea["ENV"] = "ENV";
    LoggingArea["Problems"] = "PROBLEM_SCANNER";
    LoggingArea["Git"] = "GIT";
    LoggingArea["Common"] = "COMMON";
    LoggingArea["SqlTesting"] = "SQL_TESTING";
    LoggingArea["Heartbeat"] = "HEARTBEAT";
    LoggingArea["Palette"] = "PALETTE";
    LoggingArea["Auth"] = "AUTH";
    LoggingArea["UserManagement"] = "USER_MANAGEMENT";
    LoggingArea["MetadataOperations"] = "METADATA_OPERATIONS";
    LoggingArea["Search"] = "SEARCH";
    LoggingArea["Workspaces"] = "WORKSPACES";
    LoggingArea["State"] = "STATE";
    LoggingArea["CD_2676Logger"] = "CD_2676";
    LoggingArea["UserSettings"] = "USER_SETTINGS";
    LoggingArea["AdvancedDeploy"] = "ADVANCED_DEPLOY";
    LoggingArea["MetadataHydration"] = "METADATA_HYDRATION";
    LoggingArea["TemplateEditor"] = "TEMPLATE_EDITOR";
    LoggingArea["MappingGrid"] = "MAPPING_GRID";
    LoggingArea["Pendo"] = "PENDO";
    LoggingArea["Strumenta"] = "STRUMENTA";
    LoggingArea["NarrowMetadata"] = "NARROW_METADATA";
    LoggingArea["CLI_INTERNAL"] = "CLI_INTERNAL";
    LoggingArea["DRAG"] = "DRAG";
    LoggingArea["CLI"] = "CLI";
    LoggingArea["RunTransaction"] = "RUN_TRANSACTION";
    LoggingArea["RunResults"] = "RUN_RESULTS";
    LoggingArea["Packages"] = "PACKAGES";
    LoggingArea["Jest"] = "JEST";
    LoggingArea["ORG_SCANNER"] = "ORG_SCANNER";
    LoggingArea["Projects"] = "PROJECTS";
})(LoggingArea = exports.LoggingArea || (exports.LoggingArea = {}));
var EHttpServices;
(function (EHttpServices) {
    EHttpServices["Scheduler"] = "Scheduler";
    EHttpServices["CLI"] = "CLI";
})(EHttpServices = exports.EHttpServices || (exports.EHttpServices = {}));
const myCustomLevels = {
    levels: {
        //emergency is something that should never happen that we need to take a look at, should never happen
        emerg: 0,
        //alert is an unhandled exception
        alert: 1,
        //errors can be expected
        error: 2,
        //general logging
        info: 3,
        //detailed logging for debugging an area
        debug: 4
    },
    colors: {
        emerg: "red",
        alert: "yellow",
        error: "cyan",
        info: "green",
        debug: "magenta"
    }
};
/**
 * note: these values are a workaround for the fact that our shared/ library is packaged in the front-end
 * for front-end logging, and data dog uses API_KEYS ,so instead we use client tokens stored in the front-end
 * and the API_KEY in the back-end code
 */
exports.dataDogFrontEndLogger = null;
exports.frontEndGlobalContext = {};
/**
 * defaultMeta supercedes meta passed in on individual logs, so a different context item on an individual log will not overwrite what is set here
 * @param context LogContext type object
 */
const SetBackendGlobalContext = (context) => {
    const allLoggersConfigs = {};
    Object.keys(exports.LoggingAreas).forEach(logArea => {
        allLoggersConfigs[logArea] = {
            defaultMeta: context
        };
    });
    (0, exports.ReconfigureLoggers)(allLoggersConfigs);
};
exports.SetBackendGlobalContext = SetBackendGlobalContext;
//for back-end logging, set the http transport
let datadogHTTPOptions = null;
const SetHTTPTransportOptions = (serviceName) => {
    datadogHTTPOptions = {
        host: "http-intake.logs.datadoghq.com",
        path: `/v1/input/3ae2b6d484bfaf4631d5910b5020f683?${process.env.REACT_APP_OWNER ? "ddtags=env:" + process.env.REACT_APP_OWNER : ""}&ddsource=nodejs&service=${serviceName}`,
        ssl: true
    };
};
exports.SetHTTPTransportOptions = SetHTTPTransportOptions;
class OurTransport extends transport {
    constructor(opts) {
        super(opts);
        //this maps the winston level key to the hardcoded datadog log levels
        this.levelMappings = {
            "emerg": "error",
            "alert": "warn",
            "error": "warn",
            "info": "info",
            "debug": "debug"
        };
    }
    log(info, callback) {
        if (exports.dataDogFrontEndLogger) {
            exports.dataDogFrontEndLogger.log(info, exports.frontEndGlobalContext, this.levelMappings[info.level]);
        }
        callback();
    }
}
;
/**
 * Allows reconfiguring of any number of loggers to change any of the configurable options. If a logger hasn't been initialized yet, this function will do so,
 * otherwise it will change the settings given in the new config of the existing one while using the old settings if not specified in new config.
 * Use this in any case where console logging should be shut off
 * @param newLoggerConfigs
 */
const ReconfigureLoggers = (newLoggerConfigs) => {
    Object.keys(newLoggerConfigs).forEach(loggingArea => {
        const logger = (0, exports.GetBaseLogger)(loggingArea);
        // combine old and new defaultMeta
        newLoggerConfigs[loggingArea].defaultMeta = Object.assign(Object.assign({}, logger.defaultMeta), newLoggerConfigs[loggingArea].defaultMeta);
        // transports don't appear on the logger instance like normal object, they have to be specified separately every time
        const newTransports = newLoggerConfigs[loggingArea].transports || logger.transports;
        logger.configure(Object.assign(Object.assign(Object.assign({}, logger), newLoggerConfigs[loggingArea]), { transports: newTransports }));
    });
};
exports.ReconfigureLoggers = ReconfigureLoggers;
const GetConsoleTransport = (loggingAreaInfo) => {
    return new Winston.transports.Console({
        format: defaultFormat(),
        level: loggingAreaInfo.level
    });
};
exports.GetConsoleTransport = GetConsoleTransport;
const GetHttpTransport = () => {
    return new Winston.transports.Http(Object.assign(Object.assign({}, datadogHTTPOptions), { 
        // uncolorize removed ANSI color codes from the logs sent to datadog
        format: Winston.format.combine(defaultFormat(), Winston.format.uncolorize()), level: "info", env: process.env.REACT_APP_OWNER }));
};
exports.GetHttpTransport = GetHttpTransport;
const GetOurTransport = (constructorOpts) => {
    const optionsToUse = constructorOpts !== null && constructorOpts !== void 0 ? constructorOpts : {};
    return new OurTransport(optionsToUse);
};
exports.GetOurTransport = GetOurTransport;
const GetDefaultTransports = (loggingAreaInfo) => {
    let transports = [];
    transports.push((0, exports.GetConsoleTransport)(loggingAreaInfo));
    if (datadogHTTPOptions) {
        transports.push((0, exports.GetHttpTransport)());
    }
    return [(0, exports.GetOurTransport)(), ...transports];
};
exports.GetDefaultTransports = GetDefaultTransports;
const GetStandardDefaultMeta = (loggingArea) => {
    return {
        appEnv: getAppEnvironment(),
        loggingArea
    };
};
exports.GetStandardDefaultMeta = GetStandardDefaultMeta;
/**
 * Returns an object with info about where the log is coming from i.e. localhost, dev, prod, qa and also gleans info about some environment variables that may prove useful in debugging
 * @param context the same context object passed in to the logger itself
 * @returns an object with various info about app environment as determining exact environment from one value is very difficult, maybe not possible
 */
const getAppEnvironment = () => {
    let appEnv = {
        firebaseEnv: Firebase.GetEnvironment(),
        RUNTIME_ENVIRONMENT: process.env.RUNTIME_ENVIRONMENT,
        NODE_ENVIRONMENT: process.env.NODE_ENVIRONMENT,
        START_RUN_URL: Common.START_RUN_URL
    };
    if (!Common.isCommandLine()) {
        appEnv.windowInfo = {
            frontendURLHost: window.location.host,
            ENVIRONMENT: window.ENVIRONMENT
        };
    }
    return appEnv;
};
const defaultFormat = () => {
    return Winston.format.combine(Winston.format.timestamp(), Winston.format.colorize({ colors: myCustomLevels.colors }), Winston.format.printf(info => {
        return `|${info.timestamp}|[${info.loggingArea}]|(${info.orgID ? `org:${info.orgID}; ` : ""}${info.envID ? `env:${info.envID}; ` : ""}${info.userID ? `user:${info.userID}` : ""})|${info.level}:${info.message}`;
    }));
};
exports.LoggingAreas = {
    [LoggingArea.MappingGrid]: {
        level: "info"
    },
    [LoggingArea.CD_2676Logger]: {
        level: "info"
    },
    [LoggingArea.Runner]: {
        level: "info"
    },
    [LoggingArea.Steps]: {
        level: "info"
    },
    [LoggingArea.RunnerBackend]: {
        level: "info"
    },
    [LoggingArea.Graph]: {
        level: "info"
    },
    [LoggingArea.StepTypes]: {
        level: "info"
    },
    [LoggingArea.Testing]: {
        level: "info"
    },
    [LoggingArea.UI]: {
        level: "info",
    },
    [LoggingArea.DNS]: {
        level: "info"
    },
    [LoggingArea.APP]: {
        level: "info"
    },
    [LoggingArea.Perf]: {
        level: "info"
    },
    [LoggingArea.TreeOperations]: {
        level: "info"
    },
    [LoggingArea.Deploy]: {
        level: "info"
    },
    [LoggingArea.Firebase]: {
        level: "info"
    },
    [LoggingArea.Connection]: {
        level: "info"
    },
    [LoggingArea.Environments]: {
        level: "info"
    },
    [LoggingArea.Jobs]: {
        level: "info"
    },
    [LoggingArea.SQLParsing]: {
        level: "debug"
    },
    [LoggingArea.StorageLocations]: {
        level: "info"
    },
    [LoggingArea.ENV]: {
        level: "info"
    },
    [LoggingArea.Git]: {
        level: "info"
    },
    [LoggingArea.StorageLocations]: {
        level: "info"
    },
    [LoggingArea.Common]: {
        level: "info"
    },
    [LoggingArea.ORG_SCANNER]: {
        level: "info"
    },
    [LoggingArea.SqlTesting]: {
        level: "alert"
    },
    [LoggingArea.Problems]: {
        level: "error"
    },
    [LoggingArea.Heartbeat]: {
        level: "info"
    },
    [LoggingArea.Palette]: {
        level: "info"
    },
    [LoggingArea.Auth]: {
        level: "info"
    },
    [LoggingArea.UserManagement]: {
        level: "info"
    },
    [LoggingArea.MetadataOperations]: {
        level: "info"
    },
    [LoggingArea.Search]: {
        level: "info"
    },
    [LoggingArea.Workspaces]: {
        level: "info"
    },
    [LoggingArea.State]: {
        level: "info"
    },
    [LoggingArea.UserSettings]: {
        level: "info"
    },
    [LoggingArea.AdvancedDeploy]: {
        level: "info"
    },
    [LoggingArea.MetadataHydration]: {
        level: "info"
    },
    [LoggingArea.TemplateEditor]: {
        level: "info"
    },
    [LoggingArea.Pendo]: {
        level: "info"
    },
    [LoggingArea.Strumenta]: {
        level: "info"
    },
    [LoggingArea.CLI]: {
        level: "info"
    },
    [LoggingArea.NarrowMetadata]: {
        level: "debug"
    },
    [LoggingArea.CLI_INTERNAL]: {
        level: "info"
    },
    [LoggingArea.CLI]: {
        level: "info"
    },
    [LoggingArea.DRAG]: {
        level: "info"
    },
    [LoggingArea.RunTransaction]: {
        level: "info"
    },
    [LoggingArea.RunResults]: {
        level: "info"
    },
    [LoggingArea.Packages]: {
        level: "info"
    },
    [LoggingArea.Jest]: {
        level: "info"
    },
    [LoggingArea.Projects]: {
        level: "info"
    },
};
var LogLevel;
(function (LogLevel) {
    LogLevel["emerg"] = "emerg";
    LogLevel["info"] = "info";
    LogLevel["error"] = "error";
    LogLevel["debug"] = "debug";
    LogLevel["alert"] = "alert";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
const CreateLogContext = (orgID, envID, userID) => {
    return {
        orgID,
        envID,
        userID,
    };
};
exports.CreateLogContext = CreateLogContext;
const GetBaseLogger = (loggingArea) => {
    const loggingAreaInfo = exports.LoggingAreas[loggingArea];
    if (!loggingAreaInfo.logger) {
        loggingAreaInfo.logger = Winston.createLogger({
            levels: myCustomLevels.levels,
            defaultMeta: (0, exports.GetStandardDefaultMeta)(loggingArea),
            level: loggingAreaInfo.level,
            transports: (0, exports.GetDefaultTransports)(loggingAreaInfo)
        });
    }
    return loggingAreaInfo.logger;
};
exports.GetBaseLogger = GetBaseLogger;
/**
 * Returns same logger as we had before but will now accept multiple arguments separated by commas like JS console.log()
 * and will convert them to strings and concatenate separated by spaces
 * @param loggingArea same as old loggingArea for GetLogger
 */
const GetLogger = (loggingArea) => {
    const concatArgs = (args) => {
        const stringifiedArgs = args.map(arg => {
            var _a, _b;
            switch (typeof arg) {
                case "object":
                    try {
                        switch ((_a = arg === null || arg === void 0 ? void 0 : arg.constructor) === null || _a === void 0 ? void 0 : _a.name) {
                            case "Object":
                            case "Array":
                                return JSON.stringify(arg);
                            case "Error":
                                let messageToLog = arg.toString();
                                try {
                                    //attempt to stringify the error and only log it if it isn't an empty obj (can happen depending on the Error)
                                    const returnString = JSON.stringify(arg);
                                    if (returnString !== "{}") {
                                        messageToLog = returnString;
                                    }
                                }
                                catch (error) {
                                    //swallow error and just return message to log
                                }
                                return messageToLog;
                            case "Null":
                                return "null";
                            case "Function":
                            case "RegExp":
                                return arg.toString();
                            case "Date":
                                return arg.toDateString();
                            case "ReferenceError":
                            case "TypeError":
                            case "SyntaxError":
                                return arg;
                            case undefined:
                            default:
                                return `attempting to stringify object w/ constructor: ${(_b = arg === null || arg === void 0 ? void 0 : arg.constructor) === null || _b === void 0 ? void 0 : _b.name}; ${JSON.stringify(arg)}`;
                        }
                    }
                    catch (err) {
                        return `Error converting object to string:${err}`;
                    }
                case "undefined":
                    return typeof arg;
                case "bigint":
                case "number":
                case "symbol":
                    return arg.toString();
                case "boolean":
                    return String(arg); //not sure if this is necessary but seems to be the safest according to Stack Overflow posts...
                case "string":
                    return arg;
                default:
                    return "Can't convert arg to string";
            }
        });
        return stringifiedArgs.join(" ");
    };
    const initializeNoContextLogger = (logLevel, args) => {
        const logger = (0, exports.GetBaseLogger)(loggingArea);
        const logString = concatArgs(args);
        logger.log({
            level: logLevel,
            message: logString
        });
    };
    const initializeContextLogger = (logLevel, context, args) => {
        var _a;
        // if context exists use it, otherwise prop up an empty context object
        const allStringContext = context ? Object.assign(Object.assign({}, context), { envID: (_a = context.envID) === null || _a === void 0 ? void 0 : _a.toString() }) : {};
        const loggerWithContext = (0, exports.GetBaseLogger)(loggingArea);
        const logString = concatArgs(args);
        loggerWithContext.log(Object.assign({ level: logLevel, message: logString }, allStringContext));
    };
    const info = (...args) => {
        initializeNoContextLogger("info", args);
    };
    const infoContext = (context, ...args) => {
        initializeContextLogger("info", context, args);
    };
    const emerg = (...args) => {
        initializeNoContextLogger("emerg", args);
    };
    const emergContext = (context, ...args) => {
        initializeContextLogger("emerg", context, args);
    };
    const alert = (...args) => {
        initializeNoContextLogger("alert", args);
    };
    const alertContext = (context, ...args) => {
        initializeContextLogger("alert", context, args);
    };
    const debug = (...args) => {
        initializeNoContextLogger("debug", args);
    };
    const debugContext = (context, ...args) => {
        initializeContextLogger("debug", context, args);
    };
    const error = (...args) => {
        initializeNoContextLogger("error", args);
    };
    const errorContext = (context, ...args) => {
        initializeContextLogger("error", context, args);
    };
    return { info, infoContext, emerg, emergContext, alert, alertContext, debug, debugContext, error, errorContext };
};
exports.GetLogger = GetLogger;
const MaskLogValue = (value) => {
    let maskedValue;
    if (value && value.length > 5) {
        maskedValue = "*" + value.substring(value.length - 4, value.length);
    }
    else if (!value.length) {
        // for debugging purposes, we need to know if the value passed through is empty
        maskedValue = "";
    }
    else {
        maskedValue = "****";
    }
    return maskedValue;
};
exports.MaskLogValue = MaskLogValue;
//# sourceMappingURL=Logging.js.map