"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWorkspaceEdits = exports.ConvertEnvDetailsToEnvironmentInterface = exports.CreateOldLocationName = exports.CreateWorkspaceEditForRemoveDeploySuffix = exports.CreateWorkspaceEditForCloneTable = exports.CreateWorkspaceEditForSwapCloneTable = exports.CreateWorkspaceEditForDeleteTable = exports.WorkspaceEditType = exports.GetMappingsFromWorkspaceSafe = exports.getAllWorkspaceDataFromFirebase = exports.getCollectionFromRef = exports.ReadAndValidateDataYaml = exports.GetCurrentWorkspacePhysicalLocations = exports.GetAllWorkspaceDataFromGitCommit = exports.GetRunTimeParametersFromWorkspacesSafe = exports.getCurrentWorkspaceID = exports.IsWorkspaceNameUnique = exports.GetWorkspacesAdmin = exports.GetWorkspacesCollectionAdmin = exports.GetWorkspacesCollection = exports.GetWorkspaces = exports.UpdateWorkspaceAdmin = exports.updateWorkspaceDeploy = exports.AddWorkspaceAdmin = exports.GetNewWorkspace = exports.WorkspaceSetter = exports.TransactionWorkspaceSetter = exports.GetDuplicateDevWorkspace = exports.GetNewDeployableEnvironment = exports.GetNewDevWorkspace = exports.GetInitialDevWorkspace = exports.IsUsableWorkspace = exports.IsNewEnvironment = exports.listenWorkspaceChangeCb = exports.AddMissingDefaultWorkspaceValues = exports.CheckWorkspaceNameUniqueness = exports.MarkWorkspaceStatusFailedWithCatch = exports.MarkWorkspaceStatusFailed = exports.MarkWorkspaceStatusForDeletion = exports.ReleaseWorkspaceStatus = exports.SecureWorkspaceStatus = exports.setStepColumnsAdmin = exports.deleteStepAdmin = exports.setSubgraphAdmin = exports.setStepAdmin = exports.setCollectionDocumentAdmin = exports.GetEnvironmentDocRef = exports.getWorkspacesCollectionRefAdmin = exports.getWorkspacesCollectionRef = exports.EWorkspaceVersions = void 0;
exports.IsWorkspaceLatestVersion = exports.DeleteWorkspace = exports.ScratchWorkspaceID = exports.IsDeployableEnvironment = exports.IsWorkspaceCurrentOrDeployable = exports.WorkspaceDataUpgraders = exports.UpgradeWorkspacesDataV0ToV1 = exports.GetWorkspaceDataVersion = exports.ValidateV0WorkspaceData = exports.ValidateV1WorkspaceData = exports.RV0WorkspaceData = exports.GetLatestWorkspaceDataVersion = exports.DeleteWorkspaceRecursively = exports.FlushFirestoreWorkspaceWithAllWorkspaceData = exports.isValidWorkspace = void 0;
const Common = __importStar(require("./Common"));
const Runner = __importStar(require("./Runner"));
const State = __importStar(require("./State"));
const GitOperations = __importStar(require("./GitOperation"));
const CommonOperations = __importStar(require("./CommonOperations"));
const RunnerOperations = __importStar(require("./RunnerOperations"));
const VersionControlActions = __importStar(require("./VersionControlActions"));
const Diff = __importStar(require("deep-diff"));
const Templates = __importStar(require("./Templates"));
const Immer = __importStar(require("immer"));
const StepTypes = __importStar(require("./StepTypes"));
const MetadataHydration = __importStar(require("./MetadataHydration"));
const Logging = __importStar(require("./Logging"));
const MappingOperations = __importStar(require("./MappingOperations"));
const AdvancedDeployOperations = __importStar(require("./AdvancedDeployOperations"));
const Firebase = __importStar(require("./Firebase"));
const immer = __importStar(require("immer"));
const R = __importStar(require("runtypes"));
const YAML = __importStar(require("yaml"));
const Logger = Logging.GetLogger(Logging.LoggingArea.Deploy);
const GitLogger = Logging.GetLogger(Logging.LoggingArea.Git);
const WorkspaceLogger = Logging.GetLogger(Logging.LoggingArea.Workspaces);
const BurncoCD_2676Logger = Logging.GetLogger(Logging.LoggingArea.CD_2676Logger);
const RunnerBackendLogger = Logging.GetLogger(Logging.LoggingArea.RunnerBackend);
var EWorkspaceVersions;
(function (EWorkspaceVersions) {
    // values returned here start at 0 and auto-increment (default enum behavior w/ no initializor)
    EWorkspaceVersions[EWorkspaceVersions["v0"] = 0] = "v0";
    EWorkspaceVersions[EWorkspaceVersions["v1"] = 1] = "v1";
})(EWorkspaceVersions = exports.EWorkspaceVersions || (exports.EWorkspaceVersions = {}));
const getWorkspacesCollectionRef = (teamID) => {
    return CommonOperations.getOrgConfigDocRef(teamID).collection("workspaces");
};
exports.getWorkspacesCollectionRef = getWorkspacesCollectionRef;
const getWorkspacesCollectionRefAdmin = (firestore, teamID) => {
    return CommonOperations.getOrgConfigDocRefAdmin(firestore, teamID).collection("workspaces");
};
exports.getWorkspacesCollectionRefAdmin = getWorkspacesCollectionRefAdmin;
const GetEnvironmentDocRef = (firestore, teamID, environmentID) => {
    return (0, exports.getWorkspacesCollectionRefAdmin)(firestore, teamID).doc(environmentID.toString());
};
exports.GetEnvironmentDocRef = GetEnvironmentDocRef;
const setCollectionDocumentAdmin = (firebase, teamID, workspaceID, collection, documentID, documentData) => {
    return CommonOperations.getDocumentRefAdmin(firebase.firestore(), teamID, workspaceID, collection).doc(documentID.toString()).set(documentData);
};
exports.setCollectionDocumentAdmin = setCollectionDocumentAdmin;
const setStepAdmin = (firebase, teamID, workspaceID, stepCounter, stepData) => {
    return CommonOperations.getDocumentRefAdmin(firebase.firestore(), teamID, workspaceID, "steps").doc(stepCounter.toString()).set(stepData);
};
exports.setStepAdmin = setStepAdmin;
const setSubgraphAdmin = (firebase, teamID, workspaceID, subgraphID, subgraphData) => {
    return CommonOperations.getDocumentRefAdmin(firebase.firestore(), teamID, workspaceID, "folders").doc(subgraphID.toString()).set(subgraphData);
};
exports.setSubgraphAdmin = setSubgraphAdmin;
const deleteStepAdmin = (firebase, teamID, workspaceID, stepCounter) => {
    return CommonOperations.getDocumentRefAdmin(firebase.firestore(), teamID, workspaceID, "steps").doc(stepCounter.toString()).delete();
};
exports.deleteStepAdmin = deleteStepAdmin;
const setStepColumnsAdmin = (firebase, teamID, workspaceID, stepCounter, key, data) => {
    return CommonOperations.getDocumentRefAdmin(firebase.firestore(), teamID, workspaceID, "steps").doc(stepCounter.toString()).update({
        [key]: data
    });
};
exports.setStepColumnsAdmin = setStepColumnsAdmin;
/**
 * Our mutex lock so that multiple events targeting one workspace: eg. multiple users trying to kick off deploys and refreshes doesn't succeed and only the one of the request succeeds.
 * @param firestore
 * @param teamID
 * @param workspaceID
 * @param newStatus
 * @returns
 */
const ChangeWorkspaceStatus = (firestore, teamID, workspaceID, oldExpectedStatus, newStatus) => {
    const workspaceRef = (0, exports.getWorkspacesCollectionRefAdmin)(firestore, teamID).doc(workspaceID.toString());
    return firestore.runTransaction(transaction => {
        return transaction.get(workspaceRef)
            .then((workspaceDoc) => {
            if (!workspaceDoc.exists) {
                throw new Error("IWorkspace didn't exist");
            }
            const workspaceData = workspaceDoc.data();
            /**
             * in the event that the status is undefined: for old development workspaces... we pass and set status next
             * using an array here allows us to have multiple options eg. deploys can start if we are in failed or
             * waiting state, but refresh is waiting only
             */
            if (workspaceData.status && !oldExpectedStatus.includes(workspaceData.status)) {
                throw Common.CreateErrorWithCode(400, `Unable to start ${newStatus}`, `${workspaceData.name} is ${workspaceData.status}.`);
                //deleting and waiting are acceptable values to change to for dev envs with new multiple dev env feature
            }
            else if (workspaceData.devEnv && (newStatus !== Runner.EWorkspaceHealth.deleting && newStatus !== Runner.EWorkspaceHealth.waiting)) {
                throw Common.CreateErrorWithCode(400, `Unable to refresh ${workspaceData.name}`, `${workspaceData.name} is a development environment`);
            }
            transaction.update(workspaceRef, { status: newStatus });
        });
    }).then(() => {
        Logger.debugContext({ orgID: teamID, envID: workspaceID }, "Secured mutex lock, new status: ", newStatus);
    }).catch(error => {
        Logger.errorContext({ orgID: teamID, envID: workspaceID }, "Mutex lock failure: ", error);
        throw error;
    });
};
const SecureWorkspaceStatus = (firestore, teamID, workspaceID, newStatus) => {
    //refreshes can start from waiting or failedRefresh
    const oldStatuses = [Runner.EWorkspaceHealth.waiting, Runner.EWorkspaceHealth.failedRefresh];
    //deploys can start from both of those plus failedDeploy
    if (newStatus === Runner.EWorkspaceHealth.deploying) {
        oldStatuses.push(Runner.EWorkspaceHealth.failedDeploy);
    }
    return ChangeWorkspaceStatus(firestore, teamID, workspaceID, oldStatuses, newStatus);
};
exports.SecureWorkspaceStatus = SecureWorkspaceStatus;
const ReleaseWorkspaceStatus = (firestore, teamID, workspaceID, oldExpectedStatus) => {
    return ChangeWorkspaceStatus(firestore, teamID, workspaceID, [oldExpectedStatus], Runner.EWorkspaceHealth.waiting);
};
exports.ReleaseWorkspaceStatus = ReleaseWorkspaceStatus;
const MarkWorkspaceStatusForDeletion = (firestore, teamID, workspaceID) => {
    return ChangeWorkspaceStatus(firestore, teamID, workspaceID, Object.values(Runner.EWorkspaceHealth), Runner.EWorkspaceHealth.deleting);
};
exports.MarkWorkspaceStatusForDeletion = MarkWorkspaceStatusForDeletion;
const MarkWorkspaceStatusFailed = (firestore, teamID, workspaceID, oldExpectedStatus, newFailedState) => {
    return ChangeWorkspaceStatus(firestore, teamID, workspaceID, [oldExpectedStatus], newFailedState);
};
exports.MarkWorkspaceStatusFailed = MarkWorkspaceStatusFailed;
const MarkWorkspaceStatusFailedWithCatch = (firestore, teamID, environmentID, expectedHealth, desiredHealth, logContext) => {
    return (0, exports.MarkWorkspaceStatusFailed)(firestore, teamID, environmentID, expectedHealth, desiredHealth)
        .catch(error => {
        RunnerBackendLogger.errorContext(logContext, "Error during status release: ", error);
    });
};
exports.MarkWorkspaceStatusFailedWithCatch = MarkWorkspaceStatusFailedWithCatch;
const CheckWorkspaceNameUniqueness = (workspaces, newWorkspaceName) => {
    let allWorkspaceNames;
    allWorkspaceNames = Object.values(workspaces).filter((workspace) => {
        return workspace.devEnv;
    }).map((devWorkspace) => { var _a; return (_a = devWorkspace.name) === null || _a === void 0 ? void 0 : _a.toLowerCase().trim(); });
    return allWorkspaceNames.includes(newWorkspaceName === null || newWorkspaceName === void 0 ? void 0 : newWorkspaceName.toLowerCase().trim());
};
exports.CheckWorkspaceNameUniqueness = CheckWorkspaceNameUniqueness;
// to supplement for older versions of workspace
const AddMissingDefaultWorkspaceValues = (workspace) => {
    const { oauthEnabled, oauthClientID, oauthClientSecret, connectionAccount, runTimeParameters, mappingsV1 } = workspace;
    return Immer.produce(workspace, draftWorkspace => {
        if (oauthEnabled === undefined)
            draftWorkspace.oauthEnabled = false;
        if (oauthClientID === undefined)
            draftWorkspace.oauthClientID = "";
        if (oauthClientSecret === undefined)
            draftWorkspace.oauthClientSecret = "";
        if (connectionAccount === undefined)
            draftWorkspace.connectionAccount = "";
        if (runTimeParameters === undefined)
            draftWorkspace.runTimeParameters = "";
        if (mappingsV1 === undefined)
            draftWorkspace.mappingsV1 = "";
    });
};
exports.AddMissingDefaultWorkspaceValues = AddMissingDefaultWorkspaceValues;
const listenWorkspaceChangeCb = (change, dispatch) => {
    const { type, doc } = change;
    if (type === "removed") {
        dispatch(State.getDeleteWorkspace(parseInt(doc.id)));
    }
    else if (type === "clear") {
        dispatch({ type: State.getClearAllEntityActionString(CommonOperations.ECollectionRefs.workspaces) });
    }
    else if (type === "modified") {
        dispatch(State.getUpdateWorkspace(parseInt(doc.id), doc.data()));
    }
    else if (type === "added") {
        dispatch(State.getCreateWorkspace(parseInt(doc.id), doc.data()));
    }
    else {
        console.log("unknown update type", type);
        console.assert(false);
    }
};
exports.listenWorkspaceChangeCb = listenWorkspaceChangeCb;
const IsNewEnvironment = (workspaceID) => workspaceID === exports.ScratchWorkspaceID;
exports.IsNewEnvironment = IsNewEnvironment;
/**
 * ***ONLY FOR DEV WORKSPACES, NOT DEPLOYABLE ENVS***
 *
 * @param workspace
 * @returns a boolean signifying whether or not the workspace is accessible to users
 */
const IsUsableWorkspace = (workspace) => {
    return workspace.status === Runner.EWorkspaceHealth.waiting;
};
exports.IsUsableWorkspace = IsUsableWorkspace;
/**
 * For creating the workspace provided to the user in the initialization process
 *
 * @param userID
 * @returns the metadata for a brand new workspace
 */
const GetInitialDevWorkspace = (userID) => {
    const newWorkspace = (0, exports.GetNewDevWorkspace)(userID, "DEV");
    const { newMappings, defaultStorageMapping } = MappingOperations.GetInitialMappingsInfoForNewOrg();
    newWorkspace.mappingsV1 = YAML.stringify(newMappings);
    newWorkspace.defaultStorageMapping = defaultStorageMapping;
    return newWorkspace;
};
exports.GetInitialDevWorkspace = GetInitialDevWorkspace;
const GetNewDevWorkspace = (userID, workspaceName) => {
    WorkspaceLogger.infoContext({ userID }, "Creating new deployable environment");
    const workspaceInitializationData = {
        createdBy: userID,
        name: workspaceName,
        devEnv: true,
        /**
         * all dev workspaces must be flushed and then have this status released before
         * being considered valid
         */
        status: Runner.EWorkspaceHealth.initializing
    };
    return (0, exports.GetNewWorkspace)(workspaceInitializationData);
};
exports.GetNewDevWorkspace = GetNewDevWorkspace;
const GetNewDeployableEnvironment = (userID) => {
    WorkspaceLogger.infoContext({ userID }, "Creating new deployable environment");
    const environmentInitializationData = {
        createdBy: userID,
        devEnv: false,
        /**
         * an environment is created with no need to be flushed, so once it's created
         * it's considered valid
         */
        status: Runner.EWorkspaceHealth.waiting
    };
    return (0, exports.GetNewWorkspace)(environmentInitializationData);
};
exports.GetNewDeployableEnvironment = GetNewDeployableEnvironment;
/**
 *
 * @param userID ID of the user that is creating this duplicate
 * @param workspaceData workspace data to duplicate
 * @returns a new workspace with duplicate metadata
 */
const GetDuplicateDevWorkspace = (userID, workspaceData) => {
    const newWorkspaceData = Common.CreateDeepClone(workspaceData);
    newWorkspaceData.createdAt = new Date();
    newWorkspaceData.createdBy = userID;
    newWorkspaceData.version = 1;
    newWorkspaceData.name = `${workspaceData.name} (Copy)`;
    return newWorkspaceData;
};
exports.GetDuplicateDevWorkspace = GetDuplicateDevWorkspace;
const TransactionWorkspaceSetter = (transaction) => {
    return (teamID, nextWorkspaceCounter, newWorkspaceObj) => {
        const newWorkspaceRef = (0, exports.getWorkspacesCollectionRef)(teamID).doc(nextWorkspaceCounter.toString());
        transaction.set(newWorkspaceRef, newWorkspaceObj);
        return Promise.resolve();
    };
};
exports.TransactionWorkspaceSetter = TransactionWorkspaceSetter;
const WorkspaceSetter = (teamID, nextWorkspaceCounter, newWorkspaceObj) => {
    return (0, exports.getWorkspacesCollectionRef)(teamID).doc(nextWorkspaceCounter.toString()).set(newWorkspaceObj);
};
exports.WorkspaceSetter = WorkspaceSetter;
const GetNewWorkspace = (workspaceInitData) => {
    return Object.assign(Object.assign({}, GetInitialWorkspaceInfo()), workspaceInitData);
};
exports.GetNewWorkspace = GetNewWorkspace;
const GetInitialWorkspaceInfo = () => {
    return {
        name: "",
        id: exports.ScratchWorkspaceID,
        createdAt: new Date(),
        createdBy: "",
        description: "",
        devEnv: false,
        status: Runner.EWorkspaceHealth.waiting,
        lastCommit: null,
        connectionAccount: "",
        oauthEnabled: false,
        oauthClientID: "",
        oauthClientSecret: "",
        runTimeParameters: "",
        version: (0, exports.GetLatestWorkspaceDataVersion)(),
        mappingsV1: ""
    };
};
/**
 *
 * @param firestore
 * @param teamID
 * @param workspaceName
 * @param createdByUserID
 * @returns
 */
const AddWorkspaceAdmin = (firestore, teamID, workspaceName, createdByUserID) => {
    let workspace = {
        name: workspaceName,
        id: 0,
        createdAt: new Date(),
        createdBy: createdByUserID,
        lastCommit: null,
        description: "",
        mappingsV1: "",
        devEnv: false,
        status: Runner.EWorkspaceHealth.waiting,
        connectionAccount: "",
        runTimeParameters: "",
        oauthEnabled: false,
        version: (0, exports.GetLatestWorkspaceDataVersion)()
    };
    let newWorkspaceCounter = 0;
    return CommonOperations.getNextCounter(firestore, CommonOperations.getOrgDataDocRefAdmin(firestore, teamID), CommonOperations.ECounterKeys.workspaceCounter, 1).then(workspaceCounter => {
        newWorkspaceCounter = workspaceCounter;
        workspace.id = newWorkspaceCounter;
        const obj = Object.assign({}, workspace);
        return (0, exports.getWorkspacesCollectionRefAdmin)(firestore, teamID).doc(workspace.id.toString()).set(obj);
    }).then(() => {
        WorkspaceLogger.infoContext({ orgID: teamID, envID: workspace.id }, "New workspace (admin) created:", workspace);
        return newWorkspaceCounter;
    });
};
exports.AddWorkspaceAdmin = AddWorkspaceAdmin;
// adds the mappingsV1 used at time of deploy to the deployed-to environment along with the commit used for the deploy
const updateWorkspaceDeploy = (firebase, teamID, workspaceID, mappingsV1, deployCommit) => {
    return (0, exports.getWorkspacesCollectionRefAdmin)(firebase.firestore(), teamID).doc(workspaceID.toString()).update({ mappingsV1: YAML.stringify(mappingsV1), lastCommit: deployCommit });
};
exports.updateWorkspaceDeploy = updateWorkspaceDeploy;
// use this to update the workspace health status from the scheduler service
const UpdateWorkspaceAdmin = (firestore, teamID, workspaceID, update) => {
    return (0, exports.getWorkspacesCollectionRefAdmin)(firestore, teamID).doc(workspaceID.toString()).set(update, { merge: true });
};
exports.UpdateWorkspaceAdmin = UpdateWorkspaceAdmin;
const GetWorkspaces = (teamID) => {
    return (0, exports.getWorkspacesCollectionRef)(teamID).get().then((querySnapShot) => {
        const workspacesData = [];
        querySnapShot.forEach((doc) => {
            workspacesData.push(Object.assign({}, doc.data()));
        });
        return workspacesData;
    });
};
exports.GetWorkspaces = GetWorkspaces;
const GetWorkspacesCollection = (teamID) => {
    return (0, exports.getWorkspacesCollectionRef)(teamID).get().then((querySnapShot) => {
        const workspacesCollection = {};
        querySnapShot.forEach((doc) => {
            const workspaceData = doc.data();
            workspacesCollection[workspaceData.id] = doc.data();
        });
        return workspacesCollection;
    });
};
exports.GetWorkspacesCollection = GetWorkspacesCollection;
const GetWorkspacesCollectionAdmin = (firestore, teamID) => {
    return (0, exports.getWorkspacesCollectionRefAdmin)(firestore, teamID).get().then((querySnapShot) => {
        const workspacesCollection = {};
        querySnapShot.forEach((doc) => {
            const workspaceData = doc.data();
            workspacesCollection[workspaceData.id] = doc.data();
        });
        return workspacesCollection;
    });
};
exports.GetWorkspacesCollectionAdmin = GetWorkspacesCollectionAdmin;
const GetWorkspacesAdmin = (firestore, teamID) => {
    return (0, exports.getWorkspacesCollectionRefAdmin)(firestore, teamID).get().then((querySnapShot) => {
        const workspaceIDs = [];
        querySnapShot.forEach((doc) => {
            workspaceIDs.push(Object.assign({}, doc.data()));
        });
        return workspaceIDs;
    });
};
exports.GetWorkspacesAdmin = GetWorkspacesAdmin;
const IsWorkspaceNameUnique = (name, workspaceList) => {
    return !workspaceList.some(workspace => workspace.name === name);
};
exports.IsWorkspaceNameUnique = IsWorkspaceNameUnique;
const getCurrentWorkspaceID = (state) => {
    return state.currentWorkspace;
};
exports.getCurrentWorkspaceID = getCurrentWorkspaceID;
const GetRunTimeParametersFromWorkspacesSafe = (workspaces, workspaceID) => {
    return Common.getValueSafe(workspaces, ["workspaces", workspaceID, "runTimeParameters"], "");
};
exports.GetRunTimeParametersFromWorkspacesSafe = GetRunTimeParametersFromWorkspacesSafe;
const GetAllWorkspaceDataFromGitCommit = (fsRequirements, commitOID, environmentID) => {
    if (commitOID) {
        return Common.timedLoggerPromise(`GetAllWorkspaceDataFromGitCommit when a commitOID exists`, { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, GetAllWorkspaceDataFromGitCommitInternal(fsRequirements, commitOID, environmentID));
    }
    else {
        //if there's no commitOID, then just read the files using fs.readFile....
        return Common.timedLoggerPromise("GetAllWorkspaceDataFromGitCommit when a commitOID does not exist", { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, GetAllWorkspaceDataFromFileSystemDirectory(fsRequirements, environmentID));
    }
};
exports.GetAllWorkspaceDataFromGitCommit = GetAllWorkspaceDataFromGitCommit;
const GetCurrentWorkspacePhysicalLocations = (state) => {
    const currentWorkspaceID = (0, exports.getCurrentWorkspaceID)(state);
    const currentMappingsData = (0, exports.GetMappingsFromWorkspaceSafe)(state.workspaces.workspaces[currentWorkspaceID]);
    const currentLocations = MappingOperations.GetPhysicalLocationsFromMappings(currentMappingsData, currentWorkspaceID.toString());
    return currentLocations;
};
exports.GetCurrentWorkspacePhysicalLocations = GetCurrentWorkspacePhysicalLocations;
const PromiseifiedReadDir = (filesystem, dir, environmentID) => {
    BurncoCD_2676Logger.infoContext({ envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, `PromiseifiedReadDir executes at: ${new Date()}`);
    return Common.timedLoggerPromise(`PromiseifiedReadDir with filesystem: ${filesystem} and dir: ${dir}`, { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, new Promise((resolve, reject) => {
        filesystem.readdir(dir, (err, files) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(files);
            }
        });
    }));
};
const PromiseifiedReadFile = (filesystem, dir, file, environmentID) => {
    return new Promise((resolve, reject) => {
        BurncoCD_2676Logger.infoContext({ envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, `PromiseifiedReadFile executes at: ${new Date()}`);
        /**
         * utf8 must be used here, if it's utf-8, the lightning-fs browser fs throws an
         * error and refuses to read the files
         */
        filesystem.readFile(`${dir}/${file}`, "utf8", (err, content) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(content);
            }
        });
    });
};
/**
 * Wrapper function for getAllWorkspaceDataFromGitCommit for the node fs when there's no menu to choose the target commitOID
 * @param fsRequirements
 * @returns
 */
const GetAllWorkspaceDataFromFileSystemDirectory = (fsRequirements, environmentID) => {
    return Common.timedLoggerPromise("GetAllWorkspaceDataFromFileSystemDirectory", { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, new Promise((resolve, reject) => {
        let returnSteps = {}, returnFolders = {}, returnJobs = {}, returnMacros = {}, returnStepTypes = {}, returnLocations = {}, returnDefaultMapping = null, returnVersion = EWorkspaceVersions.v0, returnProjects = {}, returnPackages = {};
        PromiseifiedReadDir(fsRequirements.fs, `${fsRequirements.dir}/nodes`, environmentID)
            .then(nodeFileNames => {
            const nodePromises = nodeFileNames.map(file => {
                return Common.timedLoggerPromise(`file: ${file}`, { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, PromiseifiedReadFile(fsRequirements.fs, `${fsRequirements.dir}/nodes`, file, environmentID));
            });
            return Promise.all(nodePromises);
        }).then(nodeYamlContent => {
            const { steps } = VersionControlActions.getReduxStateFromYaml(nodeYamlContent, "");
            returnSteps = steps;
        })
            .then(() => {
            return Common.timedLoggerPromise(`PromiseifiedReadFile data.yml`, { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, PromiseifiedReadFile(fsRequirements.fs, fsRequirements.dir, "data.yml", environmentID));
        })
            .then(dataYaml => {
            const { folders, jobs, macros, stepTypes, mappings, defaultStorageMapping, version, projects, packages } = VersionControlActions.getReduxStateFromYaml([], dataYaml);
            returnFolders = folders;
            returnJobs = jobs;
            returnMacros = macros;
            returnStepTypes = stepTypes;
            returnLocations = mappings;
            returnVersion = version;
            returnDefaultMapping = defaultStorageMapping;
            returnPackages = packages;
            returnProjects = projects;
        })
            .then(() => {
            resolve({
                steps: returnSteps,
                folders: returnFolders,
                jobs: returnJobs,
                macros: returnMacros,
                stepTypes: returnStepTypes,
                locations: returnLocations,
                defaultStorageMapping: returnDefaultMapping,
                version: returnVersion,
                projects: returnProjects,
                packages: returnPackages
            });
        }).catch(error => {
            Logger.errorContext({ orgID: Common.orgIDToLog }, "Error during GetAllWorkspaceDataFromFileSystemDirectory: ", error);
            reject(error);
        });
    }));
};
/**
 * need wrapper for using the node fs where we just use the current state of the targeted dir (current history commit)
 * @param fsRequirements
 * @param commit
 * @returns
 */
const GetAllWorkspaceDataFromGitCommitInternal = (fsRequirements, commit, environmentID) => {
    BurncoCD_2676Logger.infoContext({ envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, `GetAllWorkspaceDataFromGitCommitInternal executes at: ${new Date()}`);
    return new Promise((resolve, reject) => {
        const readFileCache = {};
        // take in commit, listFiles using the commit to know what files to read
        let returnSteps = {}, returnFolders = {}, returnJobs = {}, returnMacros = {}, returnStepTypes = {}, returnLocations = {}, returnDefaultMapping = null, returnVersion = EWorkspaceVersions.v0, returnProjects = {}, returnPackages = {};
        Common.timedLoggerPromise("listing git files", {}, Logging.LoggingArea.Git, GitOperations.GitListFiles(fsRequirements, commit))
            .then(gitFiles => {
            //remove .gitignore and data.yml, just read nodes
            const nodePromises = gitFiles.filter(name => name.includes("node")).map(file => {
                return Common.timedLoggerPromise(`nodePromises --ReadFileFromCommit in file: ${file}`, { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, GitOperations.ReadFileFromCommit(fsRequirements, commit, file, readFileCache));
            });
            return Common.timedLoggerPromise("reading node files' data", { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.Git, Promise.all(nodePromises));
        }).then(nodeYamlContent => {
            const { steps } = VersionControlActions.getReduxStateFromYaml(nodeYamlContent, "");
            returnSteps = steps;
        }).then(() => {
            return Common.timedLoggerPromise(`reading file "data.yaml"`, { envID: environmentID === null || environmentID === void 0 ? void 0 : environmentID.toString() }, Logging.LoggingArea.CD_2676Logger, GitOperations.ReadFileFromCommit(fsRequirements, commit, "data.yml", readFileCache));
        })
            .then(dataYaml => {
            const { folders, jobs, macros, stepTypes, mappings, defaultStorageMapping, version, projects, packages } = VersionControlActions.getReduxStateFromYaml([], dataYaml);
            returnFolders = folders;
            returnJobs = jobs;
            returnMacros = macros;
            returnStepTypes = stepTypes;
            returnLocations = mappings;
            returnDefaultMapping = defaultStorageMapping;
            returnVersion = version;
            returnProjects = projects;
            returnPackages = packages;
            resolve({
                steps: returnSteps,
                folders: returnFolders,
                jobs: returnJobs,
                macros: returnMacros,
                stepTypes: returnStepTypes,
                locations: returnLocations,
                defaultStorageMapping: returnDefaultMapping,
                version: returnVersion,
                projects: returnProjects,
                packages: returnPackages
            });
        }).catch(error => {
            Logger.error("Error during GetAllWorkspaceDataFromGitCommitInternal: ", error);
            reject(error);
        });
    });
};
const ReadAndValidateDataYaml = (fs, commitOID, readFileCache, logContext) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const dataYaml = yield Common.timedLoggerPromise(`reading file "data.yaml"`, logContext, Logging.LoggingArea.Workspaces, GitOperations.ReadFileFromCommit(fs, commitOID, "data.yml", readFileCache));
        WorkspaceLogger.infoContext(logContext, `Validating data.yml content`);
        VersionControlActions.ValidateCommitContent(dataYaml, "data.yml");
        return dataYaml;
    }
    catch (error) {
        // thrown error is displayed in the UI, logged error is not
        WorkspaceLogger.errorContext(logContext, `Error reading or validating data.yml: ${error}`);
        throw new Error("Unable to create new workspace. Choose a git commit with a valid data.yml.");
    }
});
exports.ReadAndValidateDataYaml = ReadAndValidateDataYaml;
//helper function for getAllWorkspaceDataFromFirebase
const getCollectionFromRef = (collectionRef, workspaceID) => {
    return Common.timedLoggerPromise("getCollectionFromRef", { envID: workspaceID === null || workspaceID === void 0 ? void 0 : workspaceID.toString() }, Logging.LoggingArea.CD_2676Logger, new Promise((resolve, reject) => {
        let collection = {};
        collectionRef.get().then((querySnapShot) => {
            BurncoCD_2676Logger.infoContext({ envID: workspaceID === null || workspaceID === void 0 ? void 0 : workspaceID.toString() }, `collectionRef.get() executes at: ${new Date()}`);
            querySnapShot.forEach((doc) => {
                collection[doc.id] = doc.data();
            });
        }).then(() => {
            BurncoCD_2676Logger.infoContext({ envID: workspaceID === null || workspaceID === void 0 ? void 0 : workspaceID.toString() }, `all querySnapShot doc.data() resolve at: ${new Date()}`);
            resolve(collection);
        }).catch(error => {
            reject(error);
        });
    }));
};
exports.getCollectionFromRef = getCollectionFromRef;
/**
 * UPDATE to grab the workspace/users collection so we know what users have connection info
 * @param firestore
 * @param teamID
 * @param workspaceID
 * @returns
 */
const getAllWorkspaceDataFromFirebase = (firestore, teamID, workspaceID) => {
    return Common.timedLoggerPromise(`getAllWorkspaceDataFromFirebase teamID: ${teamID}`, { envID: workspaceID }, Logging.LoggingArea.CD_2676Logger, new Promise((resolve, reject) => {
        const refCollectionArray = [
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "steps"),
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "folders"),
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "jobs"),
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "macros"),
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "templates"),
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "users"),
            CommonOperations.getDocumentRefAdmin(firestore, teamID, parseInt(workspaceID), "packages")
        ];
        let returnSteps = {}, returnFolders = {}, returnJobs = {}, returnMacros = {}, returnStepTypes = {}, returnUserConnections = {}, returnLocations = {}, returnPackages = {};
        const collectionPromises = refCollectionArray.map(ref => {
            return (0, exports.getCollectionFromRef)(ref, parseInt(workspaceID));
        });
        Promise.all(collectionPromises).then(collections => {
            collections.forEach(collection => {
                var _a;
                const firstObject = collection[Object.keys(collection)[0]] || {}; //in the event of an empty collection (the most likely case is folders)
                if (firstObject === null || firstObject === void 0 ? void 0 : firstObject.hasOwnProperty("sqlType")) { //steps have sqlType unique to them
                    // makes steps match redux version
                    returnSteps = Object.keys(collection).reduce((accum, stepCounter) => {
                        return Object.assign(Object.assign({}, accum), { [stepCounter]: { operation: collection[stepCounter], stepCounter: stepCounter, name: collection[stepCounter]["name"] } });
                    }, {});
                }
                else if (firstObject.hasOwnProperty("folderCounter")) { //folderCounter is unique to subgraphs
                    returnFolders = collection;
                }
                else if (firstObject["subgraphs"] && firstObject["steps"]) { //jobCounter is unique to jobs
                    returnJobs = collection;
                }
                else if (firstObject.hasOwnProperty("macroString")) { // macroString is unique to macros
                    returnMacros = collection;
                }
                else if ((_a = firstObject.metadata) === null || _a === void 0 ? void 0 : _a.templates) { // metadata.templates is unique to stepTypes
                    returnStepTypes = collection;
                }
                else if (firstObject.hasOwnProperty("connectionType")) {
                    returnUserConnections = { [workspaceID]: collection };
                }
                else if (firstObject.hasOwnProperty("createdAt") && firstObject.hasOwnProperty("status")) { // has unique combination of properties for entity "createdAt" and "status"
                    returnPackages = collection;
                }
            });
        }).then(() => {
            return (0, exports.GetWorkspacesCollectionAdmin)(firestore, teamID);
        }).then(workspacesCollection => {
            const workspaceData = workspacesCollection[workspaceID];
            const workspaceVersion = (0, exports.GetWorkspaceDataVersion)(workspaceData);
            const mappings = (0, exports.GetMappingsFromWorkspaceSafe)(workspaceData);
            if (workspaceVersion === EWorkspaceVersions.v0) {
                const upgradedMappings = MappingOperations.UpgradeDevWorkspaceMappingsV0ToV1(mappings, workspacesCollection);
                returnLocations = upgradedMappings;
            }
            else {
                Common.assert(Logging.LoggingArea.Workspaces, workspaceVersion === EWorkspaceVersions.v1, `Invalid workspace version, workspace: ${workspaceData}`);
                returnLocations = mappings;
            }
            const logContext = {
                envID: workspaceID,
                orgID: teamID
            };
            Logger.debugContext(logContext, "return steps", returnSteps);
            resolve({
                steps: returnSteps,
                folders: returnFolders,
                jobs: returnJobs,
                macros: returnMacros,
                stepTypes: returnStepTypes,
                userConnections: returnUserConnections,
                locations: returnLocations,
                packages: returnPackages
            });
        }).catch(error => {
            reject(error);
        });
    }));
};
exports.getAllWorkspaceDataFromFirebase = getAllWorkspaceDataFromFirebase;
const GetMappingsFromWorkspaceSafe = (workspaceData) => {
    const workspaceVersion = (0, exports.GetWorkspaceDataVersion)(workspaceData);
    let mappings;
    if (workspaceVersion === EWorkspaceVersions.v1) {
        if (workspaceData.mappingsV1) {
            mappings = YAML.parse(workspaceData.mappingsV1);
        }
        else {
            mappings = {};
        }
    }
    else {
        mappings = workspaceData.mappings;
    }
    return mappings;
};
exports.GetMappingsFromWorkspaceSafe = GetMappingsFromWorkspaceSafe;
var WorkspaceEditType;
(function (WorkspaceEditType) {
    WorkspaceEditType["addedTable"] = "addedTable";
    WorkspaceEditType["clonedTable"] = "clonedTable";
    WorkspaceEditType["alteredTable"] = "alteredTable";
    WorkspaceEditType["deletedTable"] = "deletedTable";
    WorkspaceEditType["addedColumn"] = "addedColumn";
    WorkspaceEditType["alteredColumn"] = "alteredColumn";
    WorkspaceEditType["renamedColumn"] = "renamedColumn";
    WorkspaceEditType["deletedColumn"] = "deletedColumn";
})(WorkspaceEditType = exports.WorkspaceEditType || (exports.WorkspaceEditType = {}));
// iterate through the keys of the columns, if they don't match, create a new piece of data 
const CreateDataForNodeMetadataForColumnAlters = (original, updated) => {
    const edits = [];
    for (const key in original) {
        if (columnKeys.has(key)) {
            const originalValue = original[key];
            const updatedValue = updated[key];
            if (originalValue !== updatedValue) {
                const dataObject = { name: original.name }; //use the original name, since alters happen before renames, we want to work with the original name
                switch (key) {
                    case "nullable":
                        dataObject["nullable"] = updatedValue;
                        break;
                    case "dataType":
                        dataObject["dataType"] = updatedValue;
                        break;
                    case "description":
                        dataObject["description"] = updatedValue;
                        break;
                    default:
                        break;
                }
                //dont want to push on an empty object, since I'm unsure if I need all the columnKeys in the set/I'm unsure what to do with the ones I'm not already working with in the switch statement above
                if (Object.keys(dataObject).length > 1) {
                    edits.push(dataObject);
                }
            }
        }
    }
    return edits;
};
const CreateWorkspaceEditsForSteps = (stepCounters, type, workspaceData, workspaceMappings, platformType, workspaceID, stepTypesParsed, runTimeParameters) => {
    const editsCollection = {};
    stepCounters.forEach(stepCounter => {
        const currentNode = workspaceData.steps[stepCounter];
        const currentStep = currentNode.operation;
        /**
         * new stepTypes will overwrite old stepTypes when spreading like below,
         * old stepTypes will fill in the gaps for missing stepTypes  in the case
         * of a first (successful) deploy, or other cases where workspaceData.stepTypes
         * is {} or contains stepTypes needed at deploy that stepTypesParsed does not contain
         */
        const newAndOldStepTypes = Object.assign(Object.assign({}, workspaceData.stepTypes), stepTypesParsed);
        const deployStrategy = AdvancedDeployOperations.GetStepDeployStrategyFromStepTypesParsed(stepCounter, workspaceData.steps, newAndOldStepTypes); // gathered from the step type
        const isDeployStrategyAdvanced = deployStrategy === AdvancedDeployOperations.EDeployStrategy.advanced;
        const workspaceEdits = [];
        let message;
        let sql;
        let dataForNodeMetadata = {};
        let invalid = false;
        let hydratedMetadata = {};
        const hydrateMetadataForWorkspaceEdit = () => {
            return MetadataHydration.hydrateMetadata(currentStep, stepCounter, workspaceData.steps, newAndOldStepTypes, workspaceMappings, null, runTimeParameters);
        };
        switch (type) {
            case WorkspaceEditType.addedTable:
                if (isDeployStrategyAdvanced) {
                    sql = StepTypes.getStepTypeTemplatesSafe(newAndOldStepTypes, currentStep.sqlType).create.templateString; // all custom advanced deploy logic lives under create
                    message = `Advanced Deployment: Created node ${currentStep.name}`;
                    hydratedMetadata = AdvancedDeployOperations.GetAddTableAdvancedHydratedMetadata(currentStep, stepCounter, null, workspaceMappings, workspaceData.steps, newAndOldStepTypes, runTimeParameters);
                }
                else {
                    if (currentStep.sqlType === Runner.ESQLType.source) {
                        message = `Adding metadata for ${currentStep.name}`;
                        sql = RunnerOperations.GetTemplateStringFromStepDetails(newAndOldStepTypes, Runner.ESQLType.source, RunnerOperations.OperationTypes.run);
                    }
                    else {
                        message = `Created node ${currentStep.name}`;
                        sql = Templates.getCreateTableTemplate(newAndOldStepTypes, currentStep.sqlType);
                    }
                    hydratedMetadata = hydrateMetadataForWorkspaceEdit();
                }
                break;
            case WorkspaceEditType.deletedTable:
                if (isDeployStrategyAdvanced) {
                    sql = StepTypes.getStepTypeTemplatesSafe(newAndOldStepTypes, currentStep.sqlType).create.templateString;
                    message = `Advanced Deployment: Deleted node ${currentStep.name}`;
                    hydratedMetadata = AdvancedDeployOperations.GetDropTableAdvancedHydratedMetadata(currentStep, stepCounter, null, workspaceMappings, workspaceData, newAndOldStepTypes, runTimeParameters);
                    if (!sql) {
                        sql = "";
                        message = `Advanced Deployment: No SQL available for ${currentStep.name}`;
                    }
                }
                else {
                    message = `Deleted node ${currentStep.name}`;
                    //temporary patch, also need to create and tack on the oldFullyQualifiedName for all deletes?
                    let mappings;
                    //in the odd event you have deployed steps but haven't deployed mappings successfully yet, and you start deleting things that did get deployed during the last few failures, catch and skip to next edit
                    try {
                        mappings = workspaceMappings;
                        dataForNodeMetadata["oldName"] = currentStep.name;
                        dataForNodeMetadata["oldLocation"] = (0, exports.CreateOldLocationName)(currentStep, mappings);
                    }
                    catch (error) {
                        console.error("Mappings for node dont exist"); //delete metadata from firestore?
                        invalid = true;
                    }
                    sql = Templates.getDeleteTableTemplate(platformType);
                    // handle SOURCE tables or invalid (error w/getting mappings) table
                    if (currentStep.sqlType === Runner.ESQLType.source || invalid) {
                        sql = "";
                        message = `Deleting metadata for ${currentStep.name}`;
                        dataForNodeMetadata = {};
                        // handle VIEW
                    }
                    else if ((currentStep.materializationType && currentStep.materializationType === Templates.materializationTypes.view) || currentStep.sqlType === Runner.ESQLType.view) {
                        sql = Templates.getDeleteViewTemplate(platformType);
                        // handle all else
                    }
                    else {
                        /**
                         * If a COALESCE_INTERNAL_TABLE is leftover in snowflake because edits failed for whatever reason,
                         * and the COALESCE_INTERNAL_TABLE is not dropped during a proceeding rename/edit,
                         * then the COALESCE_INTERNAL_TABLE will remain on snowflake.
                         * If in this state the table is neither renamed/edited, but instead deleted,
                         * then this dropCloneEdit will ensure that the errant COALESCE_INTERNAL_TABLE will be cleaned up
                         *
                         * this does not apply to advanced deploy - maintainance is entirely dependent on the
                         * user's own custom create script
                         */
                        const dropCloneEdit = CreateWorkspaceEdit(stepCounter, message, type);
                        const oldName = dataForNodeMetadata["oldName"] + Templates.deploySuffix;
                        const oldLocation = dataForNodeMetadata["oldLocation"];
                        dropCloneEdit.dataForNodeMetadata = { oldName, oldLocation };
                        dropCloneEdit.description = `Cleaning any stale data`;
                        dropCloneEdit.sql = Templates.getDeleteTableTemplate(platformType);
                        workspaceEdits.push(dropCloneEdit);
                    }
                }
                break;
            default:
                Common.assert(Logging.LoggingArea.Deploy, false, `Invalid WS Edit type when creating workspace edits - ${type} is not a valid WS Edit type`);
                break;
        }
        const newEdit = Object.assign(Object.assign({}, CreateWorkspaceEdit(stepCounter, message, type)), { sql,
            dataForNodeMetadata });
        workspaceEdits.push(newEdit);
        Common.assert(Logging.LoggingArea.Deploy, !!hydratedMetadata, `hydratedMetadata was ${hydratedMetadata} when creating workspace edits`);
        editsCollection[stepCounter] = {
            operation: currentStep,
            workspaceEdits,
            nodeMetadata: Object.assign({ operationName: currentStep.name, mapping: workspaceMappings, destinationName: currentStep.locationName }, hydratedMetadata)
        };
    });
    return editsCollection;
};
const CreateWorkspaceEdit = (stepCounter, description, type) => {
    const newEdit = {
        stepCounter: stepCounter,
        description: description,
        sql: "",
        dataForNodeMetadata: {},
        type: type,
        updateFirestore: false
    };
    return newEdit;
};
const CreateWorkspaceEditForDeleteTable = (stepCounter, locationData, platformType) => {
    const edits = [];
    const newEdit = CreateWorkspaceEdit(stepCounter, "Deleting table", WorkspaceEditType.deletedTable);
    newEdit.sql = Templates.getDeleteTableTemplate(platformType);
    newEdit.dataForNodeMetadata = locationData;
    edits.push(newEdit);
    return edits;
};
exports.CreateWorkspaceEditForDeleteTable = CreateWorkspaceEditForDeleteTable;
const CreateWorkspaceEditForSwapCloneTable = (stepCounter, locationData, platformType) => {
    const edits = [];
    const newEdit = CreateWorkspaceEdit(stepCounter, "Swapping cloned table", WorkspaceEditType.clonedTable);
    newEdit.sql = Templates.getSwapClonedTableTemplate(platformType);
    newEdit.dataForNodeMetadata = locationData;
    edits.push(newEdit);
    return edits;
};
exports.CreateWorkspaceEditForSwapCloneTable = CreateWorkspaceEditForSwapCloneTable;
const CreateWorkspaceEditForCloneTable = (stepCounter, locationData, platformType) => {
    const edits = [];
    const newEdit = CreateWorkspaceEdit(stepCounter, "Cloning table", WorkspaceEditType.clonedTable);
    newEdit.sql = Templates.getCloneTableTemplate(platformType);
    newEdit.dataForNodeMetadata = locationData;
    edits.push(newEdit);
    return edits;
};
exports.CreateWorkspaceEditForCloneTable = CreateWorkspaceEditForCloneTable;
const CreateWorkspaceEditForTableChange = (stepCounter, locationData, platformType) => {
    const edits = [];
    const newEdit = CreateWorkspaceEdit(stepCounter, "Renaming table", WorkspaceEditType.alteredTable);
    newEdit.sql = Templates.getRenameTableTemplate(platformType);
    newEdit.dataForNodeMetadata = locationData;
    edits.push(newEdit);
    return edits;
};
const CreateWorkspaceEditForRemoveDeploySuffix = (stepCounter, originalStep, mappings, platformType) => {
    const edits = [];
    const locationName = originalStep.operation.locationName;
    let oldSchema = "";
    let oldDatabase = "";
    try {
        oldSchema = mappings[locationName].schema;
        oldDatabase = mappings[locationName].database;
    }
    catch (error) {
        Logger.error(`Mappings for locationName: ${locationName} do not exist`);
        //swallow
    }
    const data = {
        oldName: originalStep.operation.name,
        oldLocation: `"${oldDatabase}"."${oldSchema}".`
    };
    const newEdit = CreateWorkspaceEdit(stepCounter, "Removing deploy suffix from table", WorkspaceEditType.alteredTable);
    newEdit.sql = Templates.getRemoveDeploySuffixTemplate(platformType);
    newEdit.dataForNodeMetadata = data;
    edits.push(newEdit);
    return edits;
};
exports.CreateWorkspaceEditForRemoveDeploySuffix = CreateWorkspaceEditForRemoveDeploySuffix;
const CreateWorkspaceEditForColumnDeletes = (originalStep, locationData, columnCounters, stepCounter, platformType) => {
    const workspaceEdits = [];
    if (columnCounters.length) {
        const columnCountersSet = new Set(columnCounters);
        const primaryEdit = CreateWorkspaceEdit(stepCounter, "Deleted Columns: ", WorkspaceEditType.deletedColumn);
        primaryEdit.dataForNodeMetadata = Object.assign(Object.assign({}, locationData), { deletedColumns: [] });
        primaryEdit.sql = Templates.getDeleteColumnTemplate(platformType);
        const searchColumns = originalStep.operation.metadata.columns;
        searchColumns.forEach(column => {
            if (columnCountersSet.has(column.columnReference.columnCounter)) {
                //get column name
                const columnName = column.name;
                primaryEdit.description += columnName + " \n";
                //drops: [ {name: string},...]
                primaryEdit.dataForNodeMetadata.deletedColumns.push({ name: columnName });
            }
        });
        workspaceEdits.push(primaryEdit);
    }
    return workspaceEdits;
};
const CreateWorkspaceEditForColumnAlters = (originalStep, updatedStep, locationData, columnCounters, stepCounter, platformType) => {
    const edits = [];
    const columnCounterSet = new Set(columnCounters);
    const primaryEdit = CreateWorkspaceEdit(stepCounter, "Alters Columns", WorkspaceEditType.alteredColumn);
    primaryEdit.sql = Templates.getAlterColumnTemplate(platformType);
    primaryEdit.dataForNodeMetadata = Object.assign(Object.assign({}, locationData), { alteredColumns: [] });
    originalStep.operation.metadata.columns.forEach((column) => {
        //reduce hits by using the set
        if (columnCounterSet.has(column.columnReference.columnCounter)) {
            //should be guaranteed to not be undefined, but check anyway for safety
            const gitColumn = updatedStep.operation.metadata.columns.find(searchColumn => searchColumn.columnReference.columnCounter === column.columnReference.columnCounter);
            if (gitColumn) {
                let newData = CreateDataForNodeMetadataForColumnAlters(column, gitColumn); //need semi colon otherwise the linter thinks I'm calling this line as a function with the next line as arguments
                primaryEdit.dataForNodeMetadata.alteredColumns.push(...newData);
            }
        }
    });
    //only add the edit if the dataForNodeMetadata got filled with at least one item
    if (primaryEdit.dataForNodeMetadata.alteredColumns.length) {
        edits.push(primaryEdit);
    }
    return edits;
};
const CreateWorkspaceEditsForColumnRenames = (originalStep, updatedStep, locationData, columnCounters, stepCounter, platformType) => {
    const edits = [];
    const columnCounterSet = new Set(columnCounters);
    originalStep.operation.metadata.columns.forEach((column) => {
        //reduce finding operations :)
        if (columnCounterSet.has(column.columnReference.columnCounter)) {
            //should always succeed based on the columnCounterSet condition
            const gitColumn = updatedStep.operation.metadata.columns.find(searchColumn => searchColumn.columnReference.columnCounter === column.columnReference.columnCounter);
            if (gitColumn && gitColumn.name !== column.name) {
                const primaryEdit = CreateWorkspaceEdit(stepCounter, `Renamed column: ${column.name} to ${gitColumn.name}`, WorkspaceEditType.renamedColumn);
                primaryEdit.sql = Templates.getRenameColumnTemplate(platformType);
                const data = { oldColumn: column, newColumn: gitColumn };
                primaryEdit.dataForNodeMetadata = Object.assign(Object.assign({}, data), locationData);
                edits.push(primaryEdit);
            }
        }
    });
    return edits;
};
const CreateStringQuotedLocation = (database, schema) => {
    if (!database || !schema) {
        throw new Error("Database or schema are empty or undefined");
    }
    return `"${database}"."${schema}".`;
};
const CreateOldLocationName = (originalOperation, originalLocationData) => {
    let database;
    let schema;
    try {
        if (!!originalOperation.database && !!originalOperation.schema) {
            database = originalOperation.database;
            schema = originalOperation.schema;
        }
        else {
            database = originalLocationData[originalOperation.locationName].database || undefined;
            schema = originalLocationData[originalOperation.locationName].schema || undefined;
        }
        return CreateStringQuotedLocation(database, schema);
    }
    catch (error) {
        Logger.error(error);
        throw error;
    }
};
exports.CreateOldLocationName = CreateOldLocationName;
const CreateWorkspaceEditForColumnAdditions = (updatedStep, locationData, columnCounters, stepCounter, platformType) => {
    const workspaceEdits = [];
    const columnCounterSet = new Set(columnCounters);
    //iterate through all columns, if the column counter is in the set, add to the edit
    if (columnCounters.length) {
        const columns = updatedStep.operation.metadata.columns;
        const primaryEdit = CreateWorkspaceEdit(stepCounter, "Created column(s): ", WorkspaceEditType.addedColumn);
        primaryEdit.sql = Templates.getAddColumnTemplate(platformType);
        primaryEdit.dataForNodeMetadata = Object.assign(Object.assign({}, locationData), { addedColumns: [] });
        columns.forEach((column, index) => {
            if (index === 0) {
                primaryEdit.stepCounter = column.columnReference.stepCounter;
            }
            if (columnCounterSet.has(column.columnReference.columnCounter)) {
                const { name, dataType, nullable, description, defaultValue } = column;
                const dataItem = { name, dataType, nullable, description, defaultValue };
                primaryEdit.dataForNodeMetadata.addedColumns.push(dataItem);
            }
        });
        workspaceEdits.push(primaryEdit);
    }
    return workspaceEdits;
};
const columnKeys = new Set(["nullable", "dataType", "description", "defaultValue"]); // how many of these do I acutally care about/can affect?
const ResetNodeDataBaseAndSchema = (node) => {
    return Immer.produce(node, draftState => {
        draftState.operation.database = "";
        draftState.operation.schema = "";
    });
};
const DetermineIfTwoNodesHaveADifference = (node1, node2) => {
    //strip out replace database/schema with "" to ensure deployed nodes don't always trigger a diff
    const cleanNode1 = ResetNodeDataBaseAndSchema(node1);
    const cleanNode2 = ResetNodeDataBaseAndSchema(node2);
    return !!Diff.diff(cleanNode1, cleanNode2);
};
const CreateWorkspaceEditsForEditedSteps = (stepCounters, originalWorkspaceData, newWorkspaceData, workspaceID, platformType, stepTypesParsed, runTimeParameters) => {
    //set of column names that we track changes for
    let editsCollection = {};
    const oldWorkspaceMappings = MappingOperations.GetPhysicalLocationsFromMappings(originalWorkspaceData.locations, workspaceID.toString());
    const newWorkspaceMappings = MappingOperations.GetPhysicalLocationsFromMappings(newWorkspaceData.locations, workspaceID.toString());
    stepCounters.forEach(stepCounter => {
        const updatedStep = newWorkspaceData.steps[stepCounter];
        const originalStep = originalWorkspaceData.steps[stepCounter];
        const updatedOperation = updatedStep.operation;
        const originalOperation = originalStep.operation;
        let startTimeMS;
        startTimeMS = Date.now();
        const deployStrategy = AdvancedDeployOperations.GetStepDeployStrategyFromStepTypesYAML(stepCounter, newWorkspaceData.steps, newWorkspaceData.stepTypes);
        Common.calculateElapsedSeconds("GetStepDeployStrategyFromStepTypesParsed", startTimeMS, Logging.LoggingArea.Steps, {});
        const isDeployStrategyAdvanced = deployStrategy === AdvancedDeployOperations.EDeployStrategy.advanced;
        const updateEditsCollection = (workspaceEdits, hydratedMetadata) => {
            editsCollection = Immer.produce(editsCollection, (draftState) => {
                draftState[stepCounter] = {
                    operation: updatedOperation,
                    workspaceEdits,
                    nodeMetadata: Object.assign({ operationName: updatedOperation.name, mapping: newWorkspaceMappings, destinationName: updatedOperation.locationName }, hydratedMetadata)
                };
            });
        };
        if (isDeployStrategyAdvanced) {
            startTimeMS = Date.now();
            const advancedDeployHydratedMetadata = AdvancedDeployOperations.GetAlterTableAdvancedHydratedMetadata(originalOperation, updatedOperation, originalWorkspaceData, newWorkspaceData, stepCounter, null, oldWorkspaceMappings, newWorkspaceMappings, runTimeParameters);
            Common.calculateElapsedSeconds("GetAlterTableAdvancedHydratedMetadata", startTimeMS, Logging.LoggingArea.Steps, {});
            const message = `Advanced Deployment: Altered node ${updatedStep.operation.name}`;
            const newEdit = Object.assign(Object.assign({}, CreateWorkspaceEdit(stepCounter, message, WorkspaceEditType.alteredTable)), { sql: StepTypes.getStepTypeTemplatesSafe(stepTypesParsed, updatedOperation.sqlType).create.templateString });
            startTimeMS = Date.now();
            updateEditsCollection([newEdit], advancedDeployHydratedMetadata);
            Common.calculateElapsedSeconds("updateEditsCollection", startTimeMS, Logging.LoggingArea.Steps, {});
            /**
             * originalSteps now include a database and schema field, so when you compare a deployed node vs
             * a non deployed node(updatedStep) there will always be a diff and some dumb edits occur, everytime
             */
        }
        else if (originalStep.operation.sqlType !== Runner.ESQLType.source) {
            startTimeMS = Date.now();
            const hasDiff = DetermineIfTwoNodesHaveADifference(originalStep, updatedStep);
            Common.calculateElapsedSeconds("DetermineIfTwoNodesHaveADifference", startTimeMS, Logging.LoggingArea.Steps, {});
            //need locationMappingDifference as a backup to create workspaceEdits when there is not a diff between the nodes, but the location data has changed behind the scenes
            /**
             * When a deploy fails, the mappings for that deployment don't get saved to the workspace,
             * therefore, in the event that you fail your first deployment, and you attempt to deploy a different
             * commit, you will have some metadata to compare against, but no mappings to build these
             * qualifiedLocation variables.  Eventually leading to sql with qualified locations like: 'undefined.
             * undefined.STG_CUSTOMER' which is invalid.  So now we try/catch the locations so we don't get
             * undefined.
             *
             * CD-1684 UPDATE
             * We now grab the database.schema from the metadata for a node from the node instead of from the
             * deployed mappings, so we can guarantee that the information always exists, this property will exist
             * only on deployed nodes, (moving forward) so need to have a workaround for if the properties don't
             * exist, ex for our existing customers/developers, we shouldn't be locked out of deploying our
             * environments by this, so finding a backup solution if the database/schema don't exist is important
             */
            let oldQualifiedLocation;
            let newQualifiedLocation;
            // new flow has us look at these values, but for backwards compatibility we check if the values exist before moving forward
            try {
                oldQualifiedLocation = (0, exports.CreateOldLocationName)(originalOperation, oldWorkspaceMappings);
            }
            catch (_a) {
                Logger.error("Missing firestore mapping data");
                oldQualifiedLocation = undefined;
            }
            try {
                newQualifiedLocation = (0, exports.CreateOldLocationName)(updatedOperation, newWorkspaceMappings);
            }
            catch (error) {
                //can happen when you forget to commit your data.yml, so your mappings aren't commited
                Logger.error("missing git mappings", error);
                newQualifiedLocation = undefined;
            }
            //if we don't have an oldQualifiedLocation, don't try to do alter statements or drop statements
            let locationMappingDifference = false;
            locationMappingDifference = oldQualifiedLocation !== undefined ? oldQualifiedLocation !== newQualifiedLocation : false;
            if (hasDiff || locationMappingDifference) {
                startTimeMS = Date.now();
                const hydratedMetadata = MetadataHydration.hydrateMetadata(updatedStep.operation, stepCounter, newWorkspaceData.steps, newWorkspaceData.stepTypes, newWorkspaceMappings, null, runTimeParameters);
                Common.calculateElapsedSeconds("hydrateMetadata", startTimeMS, Logging.LoggingArea.Steps, {});
                updateEditsCollection([], hydratedMetadata);
                const locationData = {
                    oldName: originalStep.operation.name,
                    oldLocation: oldQualifiedLocation
                };
                //handle view differently since they are simpler
                /** CD-764 && 858 */
                let dropEdit = CreateWorkspaceEdit(stepCounter, "", WorkspaceEditType.deletedTable);
                dropEdit.dataForNodeMetadata = Object.assign({}, locationData);
                let recreateEdit = CreateWorkspaceEdit(stepCounter, `Recreated View: ${updatedOperation.name}`, WorkspaceEditType.alteredTable);
                if (originalOperation.materializationType === Templates.materializationTypes.view) {
                    if (oldQualifiedLocation) {
                        dropEdit.description = `Dropped View: ${originalOperation.name}`;
                        dropEdit.sql = Templates.getDeleteViewTemplate(platformType);
                        editsCollection[stepCounter].workspaceEdits.push(dropEdit);
                    }
                    recreateEdit.description = `Recreated View: ${updatedOperation.name}`;
                    recreateEdit.sql = Templates.getCreateTableTemplate(stepTypesParsed, originalOperation.sqlType);
                    editsCollection[stepCounter].workspaceEdits.push(recreateEdit);
                    return;
                }
                /**
                 * First edit is creating a clone (clonedtable_COALESCE_INTERNAL_TABLE)
                 *  The cloned table is what is actually edited. Once edits are complete, the cloned table will be
                 * swapped or renamed
                 */
                const clonedTableEdit = (0, exports.CreateWorkspaceEditForCloneTable)(stepCounter, locationData, platformType);
                editsCollection[stepCounter].workspaceEdits.push(...clonedTableEdit);
                //setup ColumnCounter sets for doing delete, add, and alters + renames in the same manner as with the StepCounters from getWorkspaceEdits
                const originalColumnCounters = originalOperation.metadata.columns.map(column => column.columnReference.columnCounter);
                const updatedColumnCounters = updatedOperation.metadata.columns.map(column => column.columnReference.columnCounter);
                const columnCounterSets = Common.CompareAndCreateSetsFromArrays(originalColumnCounters, updatedColumnCounters);
                const deletedColumns = columnCounterSets.firstOnly;
                const addedColumns = columnCounterSets.secondOnly;
                const columnsWithPossibleEdits = columnCounterSets.inCommon;
                /**
                 * this order of operations is important based on our deployment strategy, since we can batch:
                 * deletes, adds, and alters but not renames.  The order in which we save the edits will allow us
                 * to appropriately update firestore after we have completed the renames, so once for columns, and
                 * once for the table level: as needed.
                 * column drops should come first, in the event that a column name is reused when adding a new column
                 * pass stepCounter into all of these instead of deleted columns
                 *
                 */
                startTimeMS = Date.now();
                const deletedColumnEdits = CreateWorkspaceEditForColumnDeletes(originalStep, locationData, deletedColumns, stepCounter, platformType);
                editsCollection[stepCounter].workspaceEdits.push(...deletedColumnEdits);
                Common.calculateElapsedSeconds("CreateWorkspaceEditForColumnDeletes", startTimeMS, Logging.LoggingArea.Steps, {});
                //column alters
                startTimeMS = Date.now();
                const alteredColumnEdits = CreateWorkspaceEditForColumnAlters(originalStep, updatedStep, locationData, columnsWithPossibleEdits, stepCounter, platformType);
                editsCollection[stepCounter].workspaceEdits.push(...alteredColumnEdits);
                Common.calculateElapsedSeconds("CreateWorkspaceEditForColumnAlters", startTimeMS, Logging.LoggingArea.Steps, {});
                //column renames
                startTimeMS = Date.now();
                const renamedColumnEdits = CreateWorkspaceEditsForColumnRenames(originalStep, updatedStep, locationData, columnsWithPossibleEdits, stepCounter, platformType);
                editsCollection[stepCounter].workspaceEdits.push(...renamedColumnEdits);
                Common.calculateElapsedSeconds("CreateWorkspaceEditsForColumnRenames", startTimeMS, Logging.LoggingArea.Steps, {});
                //column adds, in the event that I add a new column that reuses a name that I either drop, or just renamed away from, this won't have a conflict
                startTimeMS = Date.now();
                const addedColumnEdits = CreateWorkspaceEditForColumnAdditions(updatedStep, locationData, addedColumns, stepCounter, platformType);
                editsCollection[stepCounter].workspaceEdits.push(...addedColumnEdits);
                Common.calculateElapsedSeconds("CreateWorkspaceEditForColumnAdditions", startTimeMS, Logging.LoggingArea.Steps, {});
                const nameDifference = originalOperation.name !== updatedOperation.name;
                if (nameDifference || locationMappingDifference) {
                    //table rename
                    //renaming clone to final destination
                    let newEdits = CreateWorkspaceEditForTableChange(stepCounter, locationData, platformType);
                    //delete the old table
                    let dropTable = (0, exports.CreateWorkspaceEditForDeleteTable)(stepCounter, locationData, platformType);
                    editsCollection[stepCounter].workspaceEdits.push(...newEdits, ...dropTable);
                }
                else {
                    //NOTE: possible that locationMappingDifference == false && locationIDDifference == true (Can happen if the ID's changed but underlying locations are the same)
                    //renaming clone to final destination 
                    let newEdits = (0, exports.CreateWorkspaceEditForSwapCloneTable)(stepCounter, locationData, platformType);
                    //delete clone
                    let dropTable = (0, exports.CreateWorkspaceEditForDeleteTable)(stepCounter, Object.assign(Object.assign({}, locationData), { oldName: originalOperation.name + Templates.deploySuffix }), platformType);
                    editsCollection[stepCounter].workspaceEdits.push(...newEdits, ...dropTable);
                }
                Common.assert(Logging.LoggingArea.Deploy, !!editsCollection[stepCounter], `'editsCollection' does not contain an edit for stepCounter: ${stepCounter}`);
            }
        }
        else {
            // source node updates
            const hasDiff = DetermineIfTwoNodesHaveADifference(originalStep, updatedStep);
            if (hasDiff) {
                // make edit for metadata update and validating source exists
                let message = `Updating metadata for ${updatedOperation.name}`;
                let sql = RunnerOperations.GetTemplateStringFromStepDetails(newWorkspaceData.stepTypes, Runner.ESQLType.source, RunnerOperations.OperationTypes.run);
                const hydratedMetadata = MetadataHydration.hydrateMetadata(updatedStep.operation, stepCounter, newWorkspaceData.steps, newWorkspaceData.stepTypes, newWorkspaceMappings, null, runTimeParameters);
                const newEdit = Object.assign(Object.assign({}, CreateWorkspaceEdit(stepCounter, message, WorkspaceEditType.alteredTable)), { sql, dataForNodeMetadata: hydratedMetadata });
                updateEditsCollection([newEdit], hydratedMetadata);
            }
        }
    });
    return editsCollection;
};
const ConvertEnvDetailsToEnvironmentInterface = (envDetails) => {
    const { eName, workspaceID, eDescription, connectionAccount, oauthClientID, oauthClientSecret, oAuthEnabled, eCreatedBy, workspaceCreatedAt, runTimeParameters, eMapping, isWorkspaceDevEnv, eStatus, defaultStorageMapping } = envDetails;
    const newEnv = {
        name: eName,
        // addWorkspace will update ID
        id: workspaceID,
        description: eDescription,
        status: eStatus,
        devEnv: isWorkspaceDevEnv || false,
        createdBy: eCreatedBy,
        createdAt: workspaceCreatedAt,
        connectionAccount: connectionAccount || "",
        oauthEnabled: oAuthEnabled || false,
        oauthClientID: oauthClientID || "",
        oauthClientSecret: oauthClientSecret || "",
        runTimeParameters: runTimeParameters || "",
        lastCommit: null,
        version: (0, exports.GetLatestWorkspaceDataVersion)()
    };
    if (isWorkspaceDevEnv) {
        newEnv.mappingsV1 = YAML.stringify(eMapping);
        newEnv.defaultStorageMapping = defaultStorageMapping;
    }
    return newEnv;
};
exports.ConvertEnvDetailsToEnvironmentInterface = ConvertEnvDetailsToEnvironmentInterface;
/**
 *
 * 1. Attempt column datatypes / nullability  for a table, bundle all column alters in to one statement/workspaceEdit
 * 1b. DROP COLUMN allows for multiple column drops, batch for efficiency?
 * 2. Attempt column renames; individual workspaceEdits for each rename/add ?order?
 * 3. Update firebase column metadata / mass step.operation.metadata.columns overwrite
 * 4. Attempt rename; move table as needed
 * 5. Update firebase w/ rename finish with ste.operation.name update as needed or locationName etc.
 *
 * when I generate the mass exodus protocol, tack those on as the last workspaceEdit for all nodes
 */
//still need to check for a difference in the deployed workspace in terms of the physical locations, if they have changed and that is where the edits will need to be done, everything needs to be recreated...
const getWorkspaceEdits = (fromAllWorkspaceData, toAllWorkspaceData, workspaceID, platformType, runTimeParameters) => {
    const { subgraphEdits, jobEdits, macroEdits, stepTypeEdits, packageEdits } = CalculateEntityUpdatesForFirestoreFlush(fromAllWorkspaceData, toAllWorkspaceData);
    const stepDataEdits = CalculateDividedStepDataWithWorkspaceEdits(fromAllWorkspaceData, toAllWorkspaceData, workspaceID, platformType, runTimeParameters);
    return { nodeEdits: stepDataEdits, AllWorkspaceData: fromAllWorkspaceData, subgraphEdits, jobEdits, macroEdits, stepTypeEdits, packageEdits };
};
exports.getWorkspaceEdits = getWorkspaceEdits;
const ConvertStepsCollectionForFirestore = (stepsCollection) => {
    const convertedCollection = {};
    Object.entries(stepsCollection).forEach(([nodeID, nodeData]) => {
        const updatedNodeData = nodeData.operation;
        convertedCollection[nodeID] = updatedNodeData;
    });
    return convertedCollection;
};
const CalculateEntityUpdatesForFirestoreFlush = (fromAllWorkspaceData, toAllWorkspaceData) => {
    //reshape steps collection before feeding it into the updater function, need to have nodes that have already accessed the .operation
    const fromNodesUpdated = ConvertStepsCollectionForFirestore(fromAllWorkspaceData.steps);
    const toNodesUpdated = ConvertStepsCollectionForFirestore(toAllWorkspaceData.steps);
    const nodeEdits = CalculateDividedEntityUpdates(fromNodesUpdated, toNodesUpdated);
    const subgraphEdits = CalculateDividedEntityUpdates(fromAllWorkspaceData.folders, toAllWorkspaceData.folders);
    const jobEdits = CalculateDividedEntityUpdates(fromAllWorkspaceData.jobs, toAllWorkspaceData.jobs);
    const macroEdits = CalculateDividedEntityUpdates(fromAllWorkspaceData.macros, toAllWorkspaceData.macros);
    const stepTypeEdits = CalculateDividedEntityUpdates(fromAllWorkspaceData.stepTypes, toAllWorkspaceData.stepTypes);
    // helper for safely getting value for newer ws entities
    const getEntityValueSafe = (entityCollectionObject, path) => Common.getValueSafe(entityCollectionObject, path, {});
    // add guard rails with valueSafe since packages is new collection
    const packageEdits = CalculateDividedEntityUpdates(getEntityValueSafe(fromAllWorkspaceData, ["packages"]), getEntityValueSafe(toAllWorkspaceData, ["packages"]));
    return { nodeEdits, subgraphEdits, jobEdits, macroEdits, stepTypeEdits, packageEdits };
};
const CompareAndSplitEntityIDsBetweenEntityCollections = (fromEntityCollection, toEntityCollection) => {
    const fromEntityIDs = Object.keys(fromEntityCollection);
    const toEntityIDs = Object.keys(toEntityCollection);
    const dividedEntityIDsByCommonality = Common.CompareAndCreateSetsFromArrays(toEntityIDs, fromEntityIDs);
    const deletedEntityIDs = dividedEntityIDsByCommonality.firstOnly;
    const addedEntityIDs = dividedEntityIDsByCommonality.secondOnly;
    const entitiesWithPossibleEdits = dividedEntityIDsByCommonality.inCommon;
    return { deletedEntityIDs, addedEntityIDs, entitiesWithPossibleEdits };
};
const CalculateDividedEntityUpdates = (newEntityCollection, oldEntityCollection) => {
    const entityUpdates = { changed: {}, deleted: {} };
    const { deletedEntityIDs, addedEntityIDs, entitiesWithPossibleEdits } = CompareAndSplitEntityIDsBetweenEntityCollections(newEntityCollection, oldEntityCollection);
    //add all added to changed
    addedEntityIDs.forEach(newEntityID => {
        const newEntityData = newEntityCollection[newEntityID];
        const entityData = newEntityData;
        entityUpdates.changed[newEntityID] = entityData;
    });
    //add all deleted to deleted
    deletedEntityIDs.forEach(entityID => {
        const oldEntityData = oldEntityCollection[entityID];
        const entityData = oldEntityData;
        entityUpdates.deleted[entityID] = entityData;
    });
    //do diff on possibleEdits and add to added as needed
    entitiesWithPossibleEdits.forEach(entityID => {
        const newEntityData = newEntityCollection[entityID];
        const oldEntityData = oldEntityCollection[entityID];
        //do diff first
        if (Diff.diff(newEntityData, oldEntityData)) {
            entityUpdates.changed[entityID] = newEntityData;
        }
    });
    return entityUpdates;
};
/**
 * Internal function responsible to determining which Nodes require metadata/SQL edits during a deploy action
 * @param fromAllWorkspaceData
 * @param toAllWorkspaceData
 * @param workspaceID
 * @param platformType
 * @returns
 */
const CalculateDividedStepDataWithWorkspaceEdits = (fromAllWorkspaceData, toAllWorkspaceData, workspaceID, platformType, runTimeParameters) => {
    const stepDataEdits = { [WorkspaceEditType.addedTable]: {}, [WorkspaceEditType.alteredTable]: {}, [WorkspaceEditType.deletedTable]: {} };
    const { deletedEntityIDs, addedEntityIDs, entitiesWithPossibleEdits } = CompareAndSplitEntityIDsBetweenEntityCollections(fromAllWorkspaceData.steps, toAllWorkspaceData.steps);
    const newWorkspaceMappings = MappingOperations.GetPhysicalLocationsFromMappings(fromAllWorkspaceData.locations, workspaceID.toString());
    stepDataEdits.deletedTable = CreateWorkspaceEditsForSteps(deletedEntityIDs, WorkspaceEditType.deletedTable, toAllWorkspaceData, newWorkspaceMappings, platformType, workspaceID, fromAllWorkspaceData.stepTypes, runTimeParameters);
    stepDataEdits.addedTable = CreateWorkspaceEditsForSteps(addedEntityIDs, WorkspaceEditType.addedTable, fromAllWorkspaceData, newWorkspaceMappings, platformType, workspaceID, fromAllWorkspaceData.stepTypes, runTimeParameters);
    stepDataEdits.alteredTable = CreateWorkspaceEditsForEditedSteps(entitiesWithPossibleEdits, toAllWorkspaceData, fromAllWorkspaceData, workspaceID, platformType, fromAllWorkspaceData.stepTypes, runTimeParameters);
    return stepDataEdits;
};
const isValidWorkspace = (workspaceInfo) => {
    return workspaceInfo.hasOwnProperty("createdBy"); //createdBy is a required field - previous versions only had an id field
};
exports.isValidWorkspace = isValidWorkspace;
const CreateFirestoreUpdatesForEntityCollections = (changedAndDeletedIDForEntityCollection, collectionRef) => {
    const entityUpdates = {
        set: Object.entries(changedAndDeletedIDForEntityCollection.changed).map(([entityID, entityData]) => {
            return { id: entityID, value: entityData };
        }),
        deletes: Object.entries(changedAndDeletedIDForEntityCollection.deleted).map(([entityID, entityData]) => {
            return { id: entityID, value: entityData };
        }),
        collectionRef: collectionRef
    };
    return entityUpdates;
};
const CreateAllEntityUpdatesForBatching = (desiredWorkspaceDataState, workspaceDataToReplace) => {
    const { nodeEdits, subgraphEdits, jobEdits, macroEdits, stepTypeEdits, packageEdits } = CalculateEntityUpdatesForFirestoreFlush(desiredWorkspaceDataState, workspaceDataToReplace);
    const nodeFirestoreEdits = CreateFirestoreUpdatesForEntityCollections(nodeEdits, CommonOperations.ECollectionRefs.steps);
    const subgraphFirestoreEdits = CreateFirestoreUpdatesForEntityCollections(subgraphEdits, CommonOperations.ECollectionRefs.folders);
    const jobFirestoreEdits = CreateFirestoreUpdatesForEntityCollections(jobEdits, CommonOperations.ECollectionRefs.jobs);
    const macroFirestoreEdits = CreateFirestoreUpdatesForEntityCollections(macroEdits, CommonOperations.ECollectionRefs.macros);
    const stepTypeFirestoreEdits = CreateFirestoreUpdatesForEntityCollections(stepTypeEdits, CommonOperations.ECollectionRefs.templates);
    const packageFirestoreEdits = CreateFirestoreUpdatesForEntityCollections(packageEdits, CommonOperations.ECollectionRefs.packages);
    // deliberately excluding packages - those updates are made to FS directly when adding/removing package
    return [nodeFirestoreEdits, subgraphFirestoreEdits, jobFirestoreEdits, macroFirestoreEdits, stepTypeFirestoreEdits, packageFirestoreEdits];
};
const FlushFirestoreWorkspaceWithAllWorkspaceData = (firestore, teamID, workspaceIDForTargetFlush, desiredWorkspaceDataState, workspaceDataToReplace) => {
    return new Promise((resolve, reject) => {
        //no workspaces means no mappings (normal for build envs) so always assume this?
        GitLogger.debugContext({ orgID: teamID, envID: workspaceIDForTargetFlush }, "received Firestore data to compare");
        const updatesWithoutBatch = CreateAllEntityUpdatesForBatching(desiredWorkspaceDataState, workspaceDataToReplace);
        const allUpdatesWithAddToBatchFunction = updatesWithoutBatch
            .map((entityUpdates) => {
            // use collection ref to target correct data to update
            const { set, deletes, collectionRef } = entityUpdates;
            const collectionReference = CommonOperations.getDocumentRefAdmin(firestore, teamID, workspaceIDForTargetFlush, collectionRef);
            const setsToBatch = set.map(entity => {
                GitLogger.debug("Entity for update", entity);
                const docRef = collectionReference.doc(entity.id);
                return Common.BatchSetFirestoreDoc(docRef, entity.value);
            });
            const deletesToBatch = deletes.map(entity => {
                GitLogger.debug("Entity for update", entity);
                const docRef = collectionReference.doc(entity.id);
                return Common.BatchDeleteFirestoreDoc(docRef, entity.value);
            });
            return [...setsToBatch, ...deletesToBatch];
        }).flat();
        const storageLocationUpdates = CreateUpdatesForStorageLocations(desiredWorkspaceDataState, teamID, workspaceIDForTargetFlush, firestore);
        GitLogger.debugContext({ orgID: teamID, envID: workspaceIDForTargetFlush }, "# of Firestore updates to flush", allUpdatesWithAddToBatchFunction.length);
        return Common.FirestoreBatchBarrel(allUpdatesWithAddToBatchFunction, 500, firestore)
            .then(() => {
            // ensures all storage location updates are on same batch to avoid possible problems with v0 to v1 workspace data upgrades
            return Common.FirestoreBatchBarrel(storageLocationUpdates, 500, firestore);
        }).then(() => {
            resolve();
        }).catch(error => {
            GitLogger.emergContext({ orgID: teamID, envID: workspaceIDForTargetFlush }, "Error during FlushFirestoreWorkspaceWithAllWorkspaceData: ", error);
            reject(error);
        });
    });
};
exports.FlushFirestoreWorkspaceWithAllWorkspaceData = FlushFirestoreWorkspaceWithAllWorkspaceData;
/**
 * Helper function for abstracting the creation of storage locations during a firestore flush
 * @param nodeCollection
 * @param teamID
 * @param envID
 * @returns
 */
const CreateUpdatesForStorageLocations = (allWorkspaceData, teamID, envID, firestoreOverride) => {
    const locations = allWorkspaceData.locations;
    if (!locations || !Object.keys(locations).length) {
        return [];
    }
    Common.assert(Logging.LoggingArea.StorageLocations, MappingOperations.AreMappingsV1(locations), `locations in CreateUpdatesForStorageLocations are not v1; locations: ${locations}`);
    const defaultStorageMapping = MappingOperations.GetDefaultStorageMappingForCheckout(allWorkspaceData);
    let docRef;
    if (firestoreOverride) {
        docRef = CommonOperations.getOrgDataDocRefAdmin(firestoreOverride, teamID).collection("workspaces").doc(envID.toString());
    }
    else {
        docRef = CommonOperations.getOrgDataDocRef(teamID).collection("workspaces").doc(envID.toString());
    }
    Logger.infoContext({ orgID: teamID, envID }, "creating location batch function for v1; defaultStorageMapping:", defaultStorageMapping, "locations:", locations);
    const updates = [Common.BatchUpdateFirestoreDoc(docRef, { mappingsV1: YAML.stringify(locations), defaultStorageMapping })];
    return updates;
};
const DeleteWorkspaceRecursively = (workspaceID, teamID, fbToken) => {
    const logContext = { orgID: teamID, envID: workspaceID };
    return RunnerOperations.RunPost(Common.START_RUN_URL + `/scheduler/deleteEnvironment?id_token=${fbToken}`, { workspaceID })
        .then(() => {
        WorkspaceLogger.infoContext(logContext, "Environment successfully deleted");
    }).catch(err => {
        WorkspaceLogger.errorContext(logContext, "Error while deleting environment:", err);
    });
};
exports.DeleteWorkspaceRecursively = DeleteWorkspaceRecursively;
// WORKSPACE DATA VALIDATION
const GetLatestWorkspaceDataVersion = () => {
    const enumArray = Object.values(EWorkspaceVersions);
    return parseInt(enumArray[enumArray.length - 1]);
};
exports.GetLatestWorkspaceDataVersion = GetLatestWorkspaceDataVersion;
const RCommonWorkspaceData = R.Record({
    name: R.String,
    id: R.Number,
    oauthClientID: R.String.optional(),
    oauthClientSecret: R.String.optional(),
    oauthEnabled: R.Boolean,
    runTimeParameters: R.String.optional(),
    // R.Lazy prevents computing right away, without it Runner.EWorkspaceHealth appears undefined
    status: R.Lazy(() => Common.RuntypeFromEnum(Runner.EWorkspaceHealth)),
    connectionAccount: R.String.optional(),
    createdAt: R.Union(R.InstanceOf(Firebase.justFirebase.firestore.Timestamp), R.InstanceOf(Date)),
    createdBy: R.String,
    currentGitBranch: R.String.optional(),
    currentGitCommit: R.Union(R.String, R.Null).optional(),
    lastCommit: R.Union(R.String, R.Null),
    description: R.String.optional(),
    devEnv: R.Boolean
});
const RV1WorkspaceData = RCommonWorkspaceData.extend({
    /*
     * mappingsV1 is the yaml string of all mappings data for an individual dev environment
     * defaultStorageMapping is the locationName of the default location for same dev env; this replaces the "default" boolean
     * property on old mappings/locations and also helps to ensure only one location can be default; these are optional
     * because they won't exist on deployable envs, only dev envs
     */
    mappingsV1: R.String.optional(),
    mappings: MappingOperations.RV0Mappings.optional(),
    defaultStorageMapping: R.Union(R.String, R.Null).optional(),
    version: R.Number,
});
exports.RV0WorkspaceData = RCommonWorkspaceData.extend({
    mappings: MappingOperations.RV0Mappings
});
const ValidateV1WorkspaceData = (workspace) => {
    return CommonOperations.ValidateRunTypeConstraint(RV1WorkspaceData, workspace);
};
exports.ValidateV1WorkspaceData = ValidateV1WorkspaceData;
const ValidateV0WorkspaceData = (workspace) => {
    return CommonOperations.ValidateRunTypeConstraint(exports.RV0WorkspaceData, workspace);
};
exports.ValidateV0WorkspaceData = ValidateV0WorkspaceData;
const GetWorkspaceDataVersion = (workspace) => {
    // default is 0 because original workspace data does not have a version property; all subsequent versions should
    return Common.getValueSafe(workspace, ["version"], 0);
};
exports.GetWorkspaceDataVersion = GetWorkspaceDataVersion;
/**
 *
 * @param currentWorkspaceID
 * @param workspaces
 * @param mappings
 * @returns
 */
const UpgradeWorkspacesDataV0ToV1 = (workspaces, orgID) => {
    const newWorkspacesData = {};
    return MappingOperations.GetFBV0MappingsCollection(orgID)
        .then(oldMappings => {
        Object.keys(workspaces).forEach(workspaceID => {
            const workspace = workspaces[workspaceID];
            const workspaceVersion = (0, exports.GetWorkspaceDataVersion)(workspace);
            /**
             * it is possible for a user to trigger an update after already creating
             * a v1 workspace, since after their first upgrade, they are redirected to
             * the dashboard.
             */
            if (workspaceVersion === EWorkspaceVersions.v1) {
                newWorkspacesData[workspaceID] = workspace;
            }
            else {
                newWorkspacesData[workspaceID] = immer.produce(workspace, draftState => {
                    // runs on assumption that current workspace is the only dev env as this should be the case for v0 orgs
                    if ((0, exports.IsDeployableEnvironment)(workspace)) {
                        if (!oldMappings || !workspace.deployedWorkspaces) {
                            draftState.mappingsV1 = "";
                        }
                        else {
                            const deployedMappings = MappingOperations.UpgradeWorkspaceMappingsV0ToV1ForDeployableEnv(workspace.deployedWorkspaces);
                            draftState.mappingsV1 = YAML.stringify(deployedMappings);
                        }
                    }
                    else {
                        // if no global mappings, just create these properties with their respective empty defaults
                        if (!oldMappings) {
                            draftState.mappingsV1 = "";
                            draftState.defaultStorageMapping = null;
                        }
                        else {
                            const newMappings = MappingOperations.UpgradeDevWorkspaceMappingsV0ToV1(oldMappings, workspaces);
                            draftState.mappingsV1 = YAML.stringify(newMappings);
                            draftState.defaultStorageMapping = MappingOperations.GetDefaultStorageMappingFromV0Locations(oldMappings);
                        }
                    }
                    draftState.version = 1;
                });
            }
        });
        return newWorkspacesData;
    });
};
exports.UpgradeWorkspacesDataV0ToV1 = UpgradeWorkspacesDataV0ToV1;
exports.WorkspaceDataUpgraders = {
    [EWorkspaceVersions.v0]: exports.UpgradeWorkspacesDataV0ToV1
};
/**
 * Checks if the workspace is either the currently active dev workspace or a deployable environment. Useful for any time
 * mappings are involved as these are only stored in redux and/or edited from the app for envs that fit those criteria.
 * @param workspace workspace to check
 * @returns boolean
 */
const IsWorkspaceCurrentOrDeployable = (workspace, currentWorkspaceID) => {
    // despite typing here, currentWorkspaceID might creep in as a number in the app, so be sure to force type to be string
    return workspace.id.toString() === (currentWorkspaceID === null || currentWorkspaceID === void 0 ? void 0 : currentWorkspaceID.toString()) || (0, exports.IsDeployableEnvironment)(workspace);
};
exports.IsWorkspaceCurrentOrDeployable = IsWorkspaceCurrentOrDeployable;
const IsDeployableEnvironment = (workspace) => {
    return !workspace.devEnv;
};
exports.IsDeployableEnvironment = IsDeployableEnvironment;
// single source of truth for scratch id and for clarity when reading code where 0 has been used as an ID with no explanation
exports.ScratchWorkspaceID = 0;
/**
 * This function applies to both workspaces and environments. Just responsible
 * for deleting the targeted doc in firestore.
 */
const DeleteWorkspace = (firestore, teamID, workspaceID, fbToken) => {
    const logContext = { orgID: teamID, envID: workspaceID };
    return (0, exports.MarkWorkspaceStatusForDeletion)(firestore, teamID, parseInt(workspaceID))
        .then(() => {
        WorkspaceLogger.infoContext(logContext, `Workspace ${workspaceID} marked for deletion`);
        return (0, exports.DeleteWorkspaceRecursively)(workspaceID.toString(), teamID, fbToken);
    }).then(() => {
        WorkspaceLogger.infoContext(logContext, `Deleted workspace ${workspaceID}`);
    }).catch(err => {
        WorkspaceLogger.errorContext(logContext, "Error deleting workspace:", err);
        throw err;
    });
};
exports.DeleteWorkspace = DeleteWorkspace;
const IsWorkspaceLatestVersion = (workspace) => {
    const workspaceVersion = (0, exports.GetWorkspaceDataVersion)(workspace);
    const latestWorkspaceVersion = (0, exports.GetLatestWorkspaceDataVersion)();
    return workspaceVersion === latestWorkspaceVersion;
};
exports.IsWorkspaceLatestVersion = IsWorkspaceLatestVersion;
//# sourceMappingURL=Workspaces.js.map